Package: vmrseq
Type: Package
Title: Probabilistic Modeling of Single-cell Methylation Heterogeneity
Version: 1.5.1
Authors@R: 
     c(person("Keegan", "Korthauer", , "kkorthauer@cmmt.ubc.ca", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-4565-1654")),
      person("Ning", "Shen", , "ning.shen.wk@gmail.com", role = c("aut"),
           comment = c(ORCID = "0000-0002-2974-1086")))
Description: High-throughput single-cell measurements of DNA methylation allows studying inter-cellular epigenetic heterogeneity, but this task faces the challenges of sparsity and noise. We present vmrseq, a statistical method that overcomes these challenges and identifies variably methylated regions accurately and robustly.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.2.3
biocViews: Software, ImmunoOncology, DNAMethylation, Epigenetics,
        SingleCell, Sequencing, WholeGenome
Depends: R (>= 4.5.0)
Imports: bumphunter, dplyr, BiocParallel, DelayedArray, GenomicRanges,
        ggplot2, methods, tidyr, locfit, gamlss.dist, recommenderlab,
        HDF5Array, data.table, SummarizedExperiment, IRanges,
        S4Vectors, devtools
Suggests: knitr, rmarkdown, testthat (>= 3.0.0)
Config/testthat/edition: 3
VignetteBuilder: knitr
URL: https://github.com/nshen7/vmrseq
BugReports: https://github.com/nshen7/vmrseq/issues
git_url: https://git.bioconductor.org/packages/vmrseq
git_branch: devel
git_last_commit: f4be463
git_last_commit_date: 2026-08-06
Repository: Bioconductor 3.24
Date/Publication: 2026-08-09
NeedsCompilation: no
Packaged: 2026-08-10 00:58:29 UTC; biocbuild
Author: Keegan Korthauer [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-4565-1654>),
  Ning Shen [aut] (ORCID: <https://orcid.org/0000-0002-2974-1086>)
Maintainer: Keegan Korthauer <kkorthauer@cmmt.ubc.ca>

<p style="text-align: center;">
  <img src="man/figures/logo.png" alt="Example Image" width="70">
</p>

# vmrseq: Detecting variably methylated regions (VMRs) from single-cell bisulfite sequencing

The R package `vmrseq` is a novel computational tool developed for pinpointing variably methylated regions (VMRs) in scBS-seq data without prior knowledge on size or location. High-throughput single-cell measurements of DNA methylation allows studying inter-cellular epigenetic heterogeneity, but this task faces the challenges of sparsity and noise. vmrseq overcomes these challenges and identifies variably methylated regions accurately and robustly. 

![](man/figures/method.png)


## Installation

You can install the development version of `vmrseq` in R from Bioconductor (recommended) or GitHub with:

``` r
### Install stable version from Bioconductor
 if (!require("BiocManager", quietly = TRUE))
     install.packages("BiocManager")
BiocManager::install("vmrseq")

## Or development version from Github
# install.packages("remotes")
remotes::install_github("nshen7/vmrseq")
```

## Online Vignette

- An online vignette of 'Get Started' on the `vmrseq` package can be found at 
[https://rpubs.com/nshen7/vmrseq-vignette](https://rpubs.com/nshen7/vmrseq-vignette).
- An example workflow on scBS-seq data analysis using `vmrseq` can be found at
[https://github.com/nshen7/vmrseq-workflow-vignette](https://github.com/nshen7/vmrseq-workflow-vignette).

## Docker Image

We provide a Docker image for robust setup and use of this package. The Docker image includes all necessary dependencies for the package and vignettes. To pull the Docker image from Docker Hub, use the following command in bash:

``` bash
docker pull nshen7/vmrseq-bioc-3.19:latest
```


## Citation

Ning Shen and Keegan Korthauer. 2023. “Vmrseq: Probabilistic Modeling of Single-Cell Methylation Heterogeneity.” bioRxiv. [https://doi.org/10.1101/2023.11.20.567911](https://doi.org/10.1101/2023.11.20.567911).

## License/Copyright

[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT) 
This package is made available under an MIT license.  

#' cell_1
#'
#' This dataset is an example of a single-cell file that can be input to
#' \code{vmrseq::poolData} function. It contains the first 10000 CpG sites in
#' a random cell from mouse frontal cortext dataset published by Luo et al. (2017).
#'
#' @docType data
#' @name cell_1
#' @usage data(cell_1)
#' @format A data frame with 10000 rows and 5 variables (no column names):
#' \describe{
#'   \item{chr}{Chromosome}
#'   \item{mc_count}{Genomic coordinate}
#'   \item{pos}{Strand information}
#'   \item{strand}{Number of methylated reads}
#'   \item{total}{Number of reads in total}
#' }
#' @references Luo, Chongyuan et al. \emph{Single-cell methylomes identify neuronal
#' subtypes and regulatory elements in mammalian cortex.}. Science (New York, N.Y.)
#' vol. 357,6351 (2017): 600-604.
#' @examples
#' data(cell_1)
#' head(cell_1)
#'
"cell_1"


#' cell_2
#'
#' This dataset is an example of a single-cell file that can be input to
#' \code{vmrseq::poolData} function. It contains the first 10000 CpG sites in
#' a random cell from mouse frontal cortext dataset published by Luo et al. (2017).
#'
#' @docType data
#' @name cell_2
#' @usage data(cell_2)
#' @format A data frame with 10000 rows and 5 variables (no column names):
#' \describe{
#'   \item{chr}{Chromosome}
#'   \item{mc_count}{Genomic coordinate}
#'   \item{pos}{Strand information}
#'   \item{strand}{Number of methylated reads}
#'   \item{total}{Number of reads in total}
#' }
#' @references Luo, Chongyuan et al. \emph{Single-cell methylomes identify neuronal
#' subtypes and regulatory elements in mammalian cortex.}. Science (New York, N.Y.)
#' vol. 357,6351 (2017): 600-604.
#' @examples
#' data(cell_2)
#' head(cell_2)
#'
"cell_2"

#' cell_3
#'
#' This dataset is an example of a single-cell file that can be input to
#' \code{vmrseq::poolData} function. It contains the first 10000 CpG sites in
#' a random cell from mouse frontal cortext dataset published by Luo et al. (2017).
#'
#' @docType data
#' @name cell_3
#' @usage data(cell_3)
#' @format A data frame with 10000 rows and 5 variables (no column names):
#' \describe{
#'   \item{chr}{Chromosome}
#'   \item{mc_count}{Genomic coordinate}
#'   \item{pos}{Strand information}
#'   \item{strand}{Number of methylated reads}
#'   \item{total}{Number of reads in total}
#' }
#' @references Luo, Chongyuan et al. \emph{Single-cell methylomes identify neuronal
#' subtypes and regulatory elements in mammalian cortex.}. Science (New York, N.Y.)
#' vol. 357,6351 (2017): 600-604.
#' @examples
#' data(cell_3)
#' head(cell_3)
#'
"cell_3"



#' toy.gr
#'
#' This \code{GRanges} object. It was generated by running the example from 
#' \code{vmrseq::vmrseqSmooth} function.
#'
#' @docType data
#' @name toy.gr
#' @usage data(toy.gr)
#' @format A \code{GRanges} object.
#' @examples
#' data(toy.gr)
#' toy.gr
#'
"toy.gr"


#' toy.results
#'
#' This \code{list} object. It was generated by running the example from 
#' \code{vmrseq::vmrseqFit} function.
#'
#' @docType data
#' @name toy.results
#' @usage data(toy.results)
#' @format A \code{GRanges} object.
#' @examples
#' data(toy.results)
#' toy.results
#'
"toy.results"


# ---- Helpers for poolData ----
## Extract genomic coordinates of a particular chromosome in a cell file.
extractCoord <- function(file, chr, sep) {
  data.table::fread(cmd = paste0("zcat ", file, " | awk -F '", sep, "' '$1==\"", chr, "\"' | awk -F '", sep, "' '{print $2}'"))$V1
}

## Extract and process methylation info of a particular chromosome from a cell file.
extractInfo <- function(file, chr, sep) {
  df <- data.table::fread(cmd = paste0("zcat ", file, " | awk -F '", sep, "' '$1==\"", chr, "\"' | awk -F '", sep, "' '{print $2\"\t\"$4\"\t\"$5}'"),
                          colClasses = c('integer', 'integer', 'integer'))
  colnames(df) <- c("pos", "meth", "total")
  df <- df %>%
    dplyr::filter(meth/total == 1 | meth/total == 0) %>%
    dplyr::filter(!duplicated(pos)) %>%
    dplyr::mutate(bool = round(meth/total)) %>%
    dplyr::select(pos, bool)
  return(df)
}

## Fill NA's in missing cites per cell
fillNA <- function(file, chr, pos_full, sep) {
  # Read in cell info
  df <- extractInfo(file, chr, sep)
  
  # Fill in NA for uncovered position
  filled <- rep(NA, length(pos_full))
  ind <- which(pos_full %in% df$pos)
  if(length(ind) != nrow(df)) stop("'pos_full' does not contain all possible positions")
  filled[ind] <- df$bool
  
  return(filled)
}


# ---- Helpers for vmrseqSmooth and vmrseqFit ----

smoothMF <- function(x, y,
                     weights, chr,
                     minInSpan, bpSpan,
                     verbose,
                     parallel) {


  locfitByCluster <- function(idx) {

    yi <- y[idx]
    xi <- x[idx]
    if (!is.null(weights)) {
      weightsi <- weights[idx]
    } else {
      weightsi <- NULL
    }
    clusteri <- clusterC[idx]

    if (is.null((yi)))
      stop("y (meanMeth) is missing")
    if (is.null(xi))
      stop("x (pos) is missing")
    if (is.null(clusteri))
      stop("cluster is missing")

    df <- data.frame(posi = xi, yi = yi, weightsi = weightsi)

    # balance minInSpan and bpSpan
    nn <- minInSpan / length(idx)
    fit <- locfit(yi ~ lp(posi, nn = nn, h = bpSpan),
                  data = df, weights = weightsi, family = "gaussian",
                  maxk = 10000)
    yi <- fitted(fit)

    return(as.vector(yi))

  } # end of function `locfitByCluster`

  chr_len <- rep(chr, each = length(x))
  clusterC <- bumphunter::clusterMaker(factor(chr_len, levels=unique(chr_len)),
                                       x,
                                       assumeSorted = TRUE,
                                       maxGap = 2*bpSpan)

  Indexes <- split(seq(along = clusterC), clusterC)

  if (parallel) {
    ret <- do.call(c, bplapply(Indexes, function(idx) locfitByCluster(idx)))
  } else {
    ret <- do.call(c, lapply(Indexes, function(idx) locfitByCluster(idx)))
  }

  return(ret) # data.frame with columns: 'fitted' (numeric), 'is_smooth' (logical)

} # end of function `smoothMF`


computeVar <- function(gr, M,
                       meanMeth,
                       bpWindow,
                       sparseNAdrop,
                       parallel) {

  varByCluster <- function(idx) {

    gr_i <- gr[idx, ]
    meanMeth_i <- meanMeth[idx]

    if (!sparseNAdrop) {
      M_i <- matrix(M[idx, ], nrow = length(idx))
    } else {
      M_i <- matrix(M[idx, ] %>% as("sparseMatrix") %>% dropNA2matrix(), nrow = length(idx))
    }

    # Obtain window ranges of each site
    wds_i <- GRanges(
      seqnames = seqnames(gr_i),
      ranges = IRanges(start = start(gr_i) - round(bpWindow/2),
                       end = end(gr_i) + round(bpWindow/2))
    )
    # Find indices in gr for each window
    hits <- findOverlaps(wds_i, gr_i)
    wds_inds <- split(subjectHits(hits), queryHits(hits))

    # Matrix of 'relative methylation' or 'methylation residuals'
    rel_M_i <- M_i - meanMeth_i

    varByWindow <- function(j) {
      ind <- wds_inds[[j]]
      if (length(ind) > 1) {
        # # local constant smoothing with Gaussian kernel
        # rel_M_i_j <- rel_M_i[ind, ]
        # gr_i_j <- gr_i[ind]
        # d <- (start(gr_i_j) - start(gr_i[j])) / (bpWindow/2)
        # # w <- (1 - abs(d)^3)^3 # tricube kernel
        # w <- exp(-(2.5*d)^2/2) # gaussian kernel
        # w_mat <- matrix(w, nrow = length(d), ncol = ncol(rel_M_i), byrow = FALSE)
        # w_mat[which(is.na(rel_M_i_j))] <- NA
        # wd_meanMeths <- colSums(rel_M_i_j*w_mat, na.rm = TRUE)/colSums(w_mat, na.rm = TRUE)

        # local constant smoothing with box kernel
        wd_meanMeths <- colMeans(rel_M_i[ind, ], na.rm = TRUE)
      } else {
        wd_meanMeths <- rel_M_i[ind, ]
      }
      wd_var <- var(wd_meanMeths, na.rm = TRUE)
      return(wd_var)
    }

    var_i <- do.call(c, lapply(seq_along(wds_inds), function(j) varByWindow(j)))

    return(var_i)
  } # end of function 'varByCluster'

  clusterC <- bumphunter::clusterMaker(seqnames(gr),
                                       start(gr),
                                       assumeSorted = TRUE,
                                       maxGap = bpWindow + 1)
  Indexes <- split(seq(along = clusterC), clusterC)

  if (parallel) {
    var <- do.call(c, bplapply(Indexes, varByCluster)) %>% unname
  } else {
    var <- do.call(c, lapply(Indexes, varByCluster)) %>% unname
  }

  return(var)
} # end of function 'computeVar'

getPriorParams <- function(total) {
  pars_u <- .priorParams(median(total), type = "u")
  pars_m <- .priorParams(median(total), type = "m")
  return(list(pars_u = pars_u, pars_m = pars_m))
}

computeVarCutoff <- function(alpha, meth, total, pars_u, pars_m, n = 100000) {
  mf <- meth / total
  prob <- c(sum(mf < 0.4), sum(mf > 0.6)) / sum(mf < 0.4 | mf > 0.6)
  null_p_u <- gamlss.dist::rBEZI(n = round(n*prob[1]), mu = pars_u['mu'], sigma = pars_u['sigma'], nu = pars_u['nu'])
  null_p_m <- gamlss.dist::rBE(n = round(n*prob[2]), mu = pars_m['mu'], sigma = pars_m['sigma'])
  null_p <- c(null_p_u, null_p_m)
  null_var <- null_p * (1-null_p)
  return(quantile(null_var, 1-alpha))
}


callCandidRegion <- function(gr,
                             cutoff,
                             maxGap,
                             minNumCR,
                             bpWindow,
                             verbose,
                             parallel
) {

  ## Compute cutoff based on qVar
  mes <- "...Calling candidate regions with cutoff of %.3f on variance."
  message(sprintf(mes, cutoff))

  ## Remove rows with var==NA
  gr <- subset(gr, !is.na(gr$var))

  ## Call candidate regions
  cluster <- bumphunter::clusterMaker(chr = seqnames(gr),
                                      pos = start(gr),
                                      maxGap = maxGap,
                                      assumeSorted = TRUE)
  Indexes <- bumphunter::getSegments(x = gr$var, f = cluster,
                                     cutoff = cutoff,
                                     assumeSorted = TRUE,
                                     verbose = FALSE)

  upIndex <- Indexes$upIndex
  CRI <- upIndex[lengths(upIndex) >= minNumCR]
  if (length(CRI) == 0) CRI <- NULL

  return(CRI)
} # end of function `callCandidRegion`


searchVMR <- function(gr,
                      CRI,
                      minNumVMR,
                      tp,
                      gradient,
                      control,
                      verbose,
                      parallel) {

  # If no `tp` provided, use internal `tp0`
  if (is.null(tp)) tp <- tp0

  # Pre-computation to ease computational burden
  max_cov <- max(gr$total)
  med_cov <- median(gr$total)
  REFARRAY <- .calRefArray(max_cov = max_cov)
  CHOICEARRAY <- .calChoiceArray(REFARRAY)
  list <- .calMethArray(par_u = .priorParams(med_cov = med_cov, type = "u"),
                        par_m = .priorParams(med_cov = med_cov, type = "m"),
                        max_cov = max_cov)
  METHARRAY <- list$METHARRAY; UNMETHARRAY <- list$UNMETHARRAY

  searchVMRbyRegion <- function(i) {

    ix <- CRI[[i]]
    totals <- gr$total[ix]
    meths <- gr$meth[ix]
    pos <- start(gr[ix])

    res_1g <- .solve1Grp(pos = pos, totals = totals, meths = meths,
                         tp = tp,
                         METHARRAY = METHARRAY, UNMETHARRAY = UNMETHARRAY)

    res_2g <- .solve2Grp(gradient = gradient,
                         pos = pos, totals = totals, meths = meths,
                         tp = tp,
                         inits = control$inits, epsilon = control$epsilon,
                         backtrack = control$backtrack,
                         eta = control$eta, max_iter = control$maxIter,
                         CHOICEARRAY = CHOICEARRAY,
                         METHARRAY = METHARRAY, UNMETHARRAY = UNMETHARRAY)

    if (res_2g$loglik > res_1g$loglik) {
      vmr_inds <- .callVMR(
        state_seq_2g = res_2g$vit_path[, 1:2],
        min_n = minNumVMR
      )
      if (is.null(vmr_inds)) return(NULL)
      else return(data.frame(vmr_inds + ix[1] - 1,
                             # cr_index = i,
                             vmr_num_cpg = vmr_inds$end_ind - vmr_inds$start_ind + 1,
                             pi = res_2g$optim_pi_1,
                             n_iter = res_2g$n_iter,
                             loglik_diff = res_2g$loglik - res_1g$loglik))
    } else {
      return(NULL)
    }
  } # end of function `searchVMRbyRegion`

  if (parallel) {
    vmrs.df <- do.call(
      rbind,
      bplapply(seq_along(CRI), function(i) searchVMRbyRegion(i))
    )
  } else {
    vmrs.df <- do.call(
      rbind,
      lapply(seq_along(CRI), function(i) searchVMRbyRegion(i))
    )
  }

  # return  a data.frame with columns:
  return(vmrs.df)

} # end of function `searchVMR`


indexToGranges <- function(gr, Indexes) {
  start_inds <- vapply(Indexes, function(ix) ix[1], FUN.VALUE = 1)
  end_inds <- vapply(Indexes, function(ix) ix[length(ix)], FUN.VALUE = 1)
  num_cpg <- lengths(Indexes)
  output.gr <- GRanges(
    seqnames = seqnames(gr)[start_inds],
    ranges = IRanges(start = start(gr)[start_inds],
                     end = end(gr)[end_inds])
  )
  values(output.gr) <- DataFrame(num_cpg = num_cpg)
  return(output.gr)
}

#' Coerce a NA-dropped HDF5 matrix back to regular matrix form where NAs are not
#' dropped to 0.
#'
#' @param hdf5_assay an DelayedMatrix object with dropped NA values (e.g. an
#' assay from HDF5SummarizedExpriment object saved by vmrseq::data.pool)
#'
#' @importFrom recommenderlab dropNA2matrix
#' @return Returns a matrix.

#' @export
#' 
#' @examples
#' # load example data
#' toy.se <- HDF5Array::loadHDF5SummarizedExperiment(system.file("extdata", "toy", package = "vmrseq"))
#' 
#' # run the function
#' HDF5NAdrop2matrix(SummarizedExperiment::assays(toy.se)$M_mat)
#' 
#'
HDF5NAdrop2matrix <- function(hdf5_assay) {
  mat <- hdf5_assay |> as("matrix") |> as("sparseMatrix") |> recommenderlab::dropNA2matrix()
  return(mat)
}

#' @title Compute regional methylation information for individual cells.
#' 
#' @description This function summarize the methylated CpG count and total CpG count
#' per region per cell. 
#'
#' @param region_ranges \code{GRanges} object that contains genomic coordinates
#' of regions of interest.
#' @param SE \code{SummarizedExperiment} object with one (and only one) assay that
#' contains *binary* methylation status of CpG sites in individual cells. In usual
#' analysis workflow (of vmrseq), \code{SE} should be the output of \code{vmrseq::data.pool}.
#' @param sparseNAdrop logical value that represents whether the NA values are
#' droppped in the input \code{SE} object. \code{SE} objects output by
#' \code{vmrseq::data.pool} are NA dropped. See \code{?vmrseq::data.pool}
#' for details about NA-dropped representation.
#' @param verbose logical value that indicates whether progress messages
#' should be printed to stdout. Defaults value is TRUE.
#' @param BPPARAM a \code{BiocParallelParam} object to specify the parallel
#' backend. The default option is \code{BiocParallel::bpparam()} which will
#' automatically creates a cluster appropriate for the operating system.
#' @importFrom GenomicRanges findOverlaps granges
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom S4Vectors subjectHits queryHits
#' @return Returns a \code{SummarizedExperiment} object of dimension 
#' (# regions x # cells). In total the object contains thress assays. Specifically, 
#' `M` and `Cov` represent the number of methylated CpGs and the number of covered 
#' CpGs in each region per cell; and `MF` (stands for methylation fraction) represents 
#' the regional average methylation level computed by `M/Cov`.
#' @export
#'
#' @examples
#' 
#' # load example data
#' toy.se <- HDF5Array::loadHDF5SummarizedExperiment(system.file("extdata", "toy", package = "vmrseq"))
#' data(toy.results)
#' 
#' # run vmrseq.fit
#' regions.se <- regionSummary(SE = toy.se, region_ranges = toy.results$vmr.ranges[1:3])
#' regions.se
#' 
regionSummary <- function(
    SE,
    region_ranges,
    sparseNAdrop = is_sparse(assays(SE)[[1]]),
    verbose = TRUE,
    BPPARAM = BiocParallel::bpparam()
) {
  
  # Register the parallel backend
  BiocParallel::register(BPPARAM)
  backend <- paste0("BiocParallel:", class(bpparam())[1])
  if (bpparam()$workers == 1) {
    if (verbose) {
      mes <- "Parallel: Using a single core (backend: %s)."
      message(sprintf(mes, backend))
    }
    parallel <- FALSE
  } else {
    if (verbose) {
      mes <- paste0("Parallel: Parallelizing using %s workers/cores ",
                    "(backend: %s).")
      message(sprintf(mes, bpparam()$workers, backend))
    }
    parallel <- TRUE
  }
  
  ## Fing the CpG sites that locate within the targeted regions
  hits <- GenomicRanges::findOverlaps(GenomicRanges::granges(SE), region_ranges)

  if (length(hits) > 0) {
    
    idx <- unique(S4Vectors::subjectHits(hits))

    M_mat <- assays(SE)$M_mat

    computeRegionStats <- function(i) { # i th feature/window
      
      mat <- M_mat[S4Vectors::queryHits(hits)[S4Vectors::subjectHits(hits)==i], ] %>% 
        matrix(ncol = ncol(SE))
      
      if (!sparseNAdrop) {
        return(list(
          "M" = colSums(mat, na.rm = TRUE),
          "Cov" = colSums(mat >= 0, na.rm = TRUE)
        ))
      } else {
        return(list(
          "M" = round(colSums(mat)),
          "Cov" = colSums(mat > 0)
        ))
      }
    }
    lists <- bplapply(idx, computeRegionStats)
    M <- do.call(
      rbind,
      lapply(lists, function(l) l$M)
    )
    Cov <- do.call(
      rbind,
      lapply(lists, function(l) l$Cov)
    )

    regions.se <- SummarizedExperiment::SummarizedExperiment(
      assays = list("M" = M, "Cov" = Cov, "MF" = M/Cov),
      rowRanges = region_ranges[idx]
    )
  }

  return(regions.se)
}

#' Pool single-cell file together into an HDF5-based SummarizedExperiment
#' object with sparse matrix representation.
#'
#' @description This function pools individual-cell CpG read files into a
#' SummarizedExperiment object so that it can be input to the \code{vmrseq.smooth}
#' function. Note that in each cell, sites with hemimethylation or intermediate
#' methylation levels (i.e., 0 < meth_read/total_read < 1) will be removed.
#'
#' @param cellFiles Vector of character strings indicating single-cell file
#' paths you wish to pool into SE object(s). Cell files should be in BED-like
#' format, where the first 5 columns in each file must be: <chr>, <pos>, <strand>,
#' <meth_read>, <total_read>, in strict order. Each row contains info of one CpG.
#' Strand is assumed to be properly filpped. Cell files can be zipped ones in .gz
#' format.
#' @param sep the field separator character. Values on each line of cell file are
#' separated by this character.
#' @param writeDir A single character string indicating a folder directory where
#' you wish to store the processed SE object(s). The SE will be stored in HDF5 format.
#' @param chrNames Single or a vector of character strings representing chromosome
#' names in cell files. Only chromosomes listed in \code{selectChrs} will be
#' processed.
#' @param colData A DataFrame or data.frame object containing colData for the SE
#' object (applied to all chromosomes).
#' @param sparseNAdrop Logical value indicating whether or not to use NA-dropped
#' sparseMatrix representation. 'NA-dropped' means replacing NAs as zeros and
#' then represent 0 as a very small positive value close to 0 so that the data
#' matrix is converted to a traditional sparseMatrix form with 0 as default
#' entry value. (see \code{sparseNAMatrix-class} from package \code{recommenderlab}).
#' Using NA-dropped sparseMatrix representation helps to save RAM during data
#' processing, as well as storage space saving to disk. Currently only supports
#' TRUE!!
#'
#' @importFrom recommenderlab dropNA
#' @importFrom data.table fread
#' @importFrom dplyr filter mutate select
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom HDF5Array saveHDF5SummarizedExperiment
#' @importFrom GenomicRanges GRanges
#' @importFrom IRanges IRanges
#' @importFrom DelayedArray rowSums
#' @importFrom S4Vectors DataFrame

#'
#' @return Directly write out to the `writeDir` and does not return anything.
#' @export
#'
#' @examples
#' \donttest{poolData(cellFiles = your_cell_file_list, sep = ",", chrNames = "chr1", writeDir = "your/write/path")}
#' 

poolData <- function(cellFiles,
                     sep,
                     writeDir,
                     chrNames,
                     colData = NULL,
                     sparseNAdrop = TRUE) {
  
  # TODO: making checks on input data format
  chrNames <- as.character(chrNames)

  if (!all(chrNames %in% unlist(fread(cellFiles[1], select = 1, colClasses = 'character'))))
    stop('Chromosomes not all found in first cell file (`cellFiles[1]`)!')

  if (!file.exists(writeDir)) dir.create(writeDir)

  if (!sparseNAdrop) stop("Sorry, `sparseNAdrop=FALSE` has not been implemented yet!")

  if (!is.null(colData)) {
    if (nrow(colData) != length(cellFiles)) stop('Number of rows of colData should equal to length of cellFiles!')
  }

  message("Start processing chromosome-by-chromosome...")


  for (chr in chrNames) {
    message(paste0("...", chr, ": "), appendLF = FALSE)

    # Gather genomic coordinates
    pos_full <- extractCoord(cellFiles[1], chr, sep)
    for (i in 2:length(cellFiles)) {
      pos_temp <- extractCoord(cellFiles[i], chr, sep)
      pos_new <- pos_temp[which(!pos_temp %in% pos_full)]
      pos_full <- c(pos_full, pos_new)
      # cat(i)
    }
    pos_full <- sort(unique(pos_full))
    message("coordinates gathered; ", appendLF = FALSE)

    # Process cell info and assemble into matrix form and summarized info to a GRanges obj
    if (sparseNAdrop) {
      M_mat <- NULL
      for (i in 1:length(cellFiles)) {
        M_mat <- cbind(
          M_mat,
          fillNA(cellFiles[i], chr, pos_full, sep) %>%
            as.matrix() %>%
            recommenderlab::dropNA()
        )
        # cat(i, " ")
      }
      gr <- GenomicRanges::GRanges(seqnames = chr, ranges = IRanges::IRanges(start = pos_full, end = pos_full))
      gr$meth <- as.integer(round(DelayedArray::rowSums(M_mat)))
      gr$total <- as.integer(DelayedArray::rowSums(M_mat > 0))
    } else {
      break # TODO
    }
    message("cells processed; ", appendLF = FALSE)

    # Write out processed data for current chromosome
    if (is.null(colData)) {
      se <- SummarizedExperiment::SummarizedExperiment(assays = list(M_mat = M_mat),
                                                       rowRanges = gr)
    } else {
      se <- SummarizedExperiment::SummarizedExperiment(assays = list(M_mat = M_mat),
                                                       rowRanges = gr,
                                                       colData = S4Vectors::DataFrame(colData))
    }
    se <- se[granges(se)$total > 0, ]

    n <- nchar(writeDir); if(substring(writeDir, n, n)=='/') writeDir <- substring(writeDir,1, n-1)
    HDF5Array::saveHDF5SummarizedExperiment(
      x = se,
      dir = paste0(writeDir, "/", chr),
      replace = TRUE
    )
    message("processed file written out.")
    if (sparseNAdrop) message("Important note: the `M_mat` assay is stored in NA-dropped sparse matrix format!")
  }
}

#' @title Auxiliary function as user interface for vmrseq optimization.
#'
#' @description Typically only used when calling vmrseq function with the
#' option \code{control}.
#'
#' @param inits vector of numeric values between 0 and 1 representing initial
#' values of pi_1 shall be taken in optimization algorithm.
#' @param epsilon numeric value representing the convergence upper bound for
#' the algorithm.
#' @param backtrack logical value indicating whether to use backtracking line
#' search to automatically adjust learning rate. Default is TRUE.
#' @param eta a numeric value representing the learning rate in optimization.
#' Default is \code{ifelse(backtrack, 0.05, 0.005)}.
#' @param maxIter positive integer value representing the maximum number of
#' iterations in optimization algorithm.
#'
#' @return the list of arguments for optimization control
#'
#' @export
#' 
#' @examples
#' vmrseqOptimControl()
#' 
#'
vmrseqOptimControl <- function(
    inits = c(.2, .5, .8),
    epsilon = 1e-3,
    backtrack = TRUE,
    eta = ifelse(backtrack, 0.05, 0.005),
    maxIter = 100
) {
  if (any(inits <= 0 | inits >= 1)) stop('All values in inits has to between 0 and 1!')
  return(list(inits = inits, epsilon = epsilon,
              backtrack = backtrack,
              eta = eta, maxIter = maxIter))
}

library(testthat)

# Test 1: Check that the function returns a list with the correct structure
test_that("vmrseqOptimControl returns a list with the correct structure", {
  result <- vmrseqOptimControl()
  
  # Check that the result is a list
  expect_type(result, "list")
  
  # Check that the list contains all expected elements
  expect_named(result, c("inits", "epsilon", "backtrack", "eta", "maxIter"))
  
  # Check types of each element
  expect_type(result$inits, "double")    # inits should be numeric
  expect_type(result$epsilon, "double")  # epsilon should be numeric
  expect_type(result$backtrack, "logical")  # backtrack should be logical
  expect_type(result$eta, "double")      # eta should be numeric
  expect_type(result$maxIter, "double")  # maxIter should be numeric
})

# Test 2: Check default values
test_that("vmrseqOptimControl returns correct default values", {
  result <- vmrseqOptimControl()
  
  expect_equal(result$inits, c(0.2, 0.5, 0.8))
  expect_equal(result$epsilon, 1e-3)
  expect_true(result$backtrack)
  expect_equal(result$eta, 0.05)  # Default eta when backtrack = TRUE
  expect_equal(result$maxIter, 100)
})

# Test 3: Check that custom values are used correctly
test_that("vmrseqOptimControl uses custom parameter values", {
  custom_inits <- c(0.1, 0.4, 0.9)
  custom_epsilon <- 1e-5
  custom_backtrack <- FALSE
  custom_eta <- 0.01
  custom_maxIter <- 200
  
  result <- vmrseqOptimControl(
    inits = custom_inits,
    epsilon = custom_epsilon,
    backtrack = custom_backtrack,
    eta = custom_eta,
    maxIter = custom_maxIter
  )
  
  expect_equal(result$inits, custom_inits)
  expect_equal(result$epsilon, custom_epsilon)
  expect_false(result$backtrack)
  expect_equal(result$eta, custom_eta)
  expect_equal(result$maxIter, custom_maxIter)
})

# Test 4: Check that eta defaults based on backtrack
test_that("vmrseqOptimControl adjusts eta based on backtrack", {
  # When backtrack is TRUE, eta should be 0.05
  result_with_backtrack <- vmrseqOptimControl(backtrack = TRUE)
  expect_equal(result_with_backtrack$eta, 0.05)
  
  # When backtrack is FALSE, eta should default to 0.005
  result_without_backtrack <- vmrseqOptimControl(backtrack = FALSE)
  expect_equal(result_without_backtrack$eta, 0.005)
})

# Test 5: Check that inits values outside the range (0, 1) trigger an error
test_that("vmrseqOptimControl throws an error for invalid inits values", {
  # Create invalid inits vectors
  invalid_inits_low <- c(-0.1, 0.5, 0.8)     # Contains a value < 0
  invalid_inits_high <- c(0.2, 0.5, 1.1)      # Contains a value > 1
  invalid_inits_edge <- c(0, 0.5, 0.8)        # Contains a value exactly at 0
  
  # Expect an error when inits values are outside the valid range (0, 1)
  expect_error(vmrseqOptimControl(inits = invalid_inits_low), 
               "All values in inits has to between 0 and 1!")
  
  expect_error(vmrseqOptimControl(inits = invalid_inits_high), 
               "All values in inits has to between 0 and 1!")
  
  expect_error(vmrseqOptimControl(inits = invalid_inits_edge), 
               "All values in inits has to between 0 and 1!")
  
  # Valid inits should not throw an error
  valid_inits <- c(0.1, 0.5, 0.9)
  expect_silent(vmrseqOptimControl(inits = valid_inits))
})

###### utils =====
# For computing REFARRAY, i.e., array of log factorial of length `max_cov` -- for the purpose of easy computation
.calRefArray <- function(max_cov) cumsum(log(seq_len(max_cov)))

# Outputs the log factorial with Stirling's approximation when int >= max_cov
.logFactorial <- function(int, REFARRAY){
  # `int` is a non-negative integer
  if(int == 0) return(0)
  else if(int <= length(REFARRAY)) return(REFARRAY[int]) # = cumsum(log(1:int))
  else return(int*log(int) - int + 0.5*log(2*pi*int))
}

.logChoose <- function(n, k, REFARRAY){
  if (k > n) return(-Inf)
  else return(.logFactorial(n, REFARRAY) - .logFactorial(k, REFARRAY) - .logFactorial(n - k, REFARRAY))
}

# Computes the log-choose(n,k) matrix
.calChoiceArray <- function(REFARRAY){
  # To store the values when n or k equals 0, we add one dimension for both row and column
  # thus the choose(n, k) is CHOICEARRAY[n+1, k+1]
  max_cov <- length(REFARRAY)
  CHOICEARRAY <- matrix(0, max_cov+1, max_cov+1)

  for(n in seq_len(max_cov+1))
    for(k in seq_len(n))
      CHOICEARRAY[n,k] <- .logChoose(n-1, k-1, REFARRAY)

  rownames(CHOICEARRAY) <- colnames(CHOICEARRAY) <- 0:max_cov
  return(CHOICEARRAY)
}

# Estimates parameters in beta-mixture priors based on number of cells.
.priorParams <- function(med_cov, type){
  # `med_cov` is the median across-cell coverage in the input dataset.
  # `type` should be 'u' or 'm' indicating grouping type.

  stopifnot("`type` should be either 'u' or 'm'." = type %in% c('u','m'))
  # stopifnot("`med_cov` should be a positive integer." = med_cov > 0 & round(med_cov)==med_cov)
  med_cov <- round(med_cov) %>% max(1)

  if (type == 'u') {
    pars <- params_u
    max_mc <- max(pars$med_cov)
    if (med_cov > max_mc) {
      return(c(nu = pars$nu[max_mc], mu = pars$mu[max_mc], sigma = pars$sigma[max_mc]))
    } else {
      return(c(nu = pars$nu[med_cov], mu = pars$mu[med_cov], sigma = pars$sigma[med_cov]))
    }
  } else {
    pars <- params_m
    return(c(mu = pars$mu[1], sigma = pars$sigma[1]))
  }
}

.calMethArray <- function(par_u, par_m, max_cov){
  # To store the values when n or k equals 0, we add one dimension for both row and column
  # thus the betaBinom(n, k) - i.e. k methylated from n reads - is METHARRAY[n+1, k+1] or UNMETHARRAY[n+1, k+1]
  # `par_u` should be 3 parameters in beta-mixture prior (unmethylated): c(w_1, beta_1, beta_2), where the mixture is w_1*dbeta(1, beta_1) + (1-w_1)*dbeta(1, beta_2)
  # `par_m` should be 3 parameters in beta-mixture prior (methylated): c(w_1, alpha_1, alpha_2), where the mixture is w_1*dbeta(alpha_1, 1) + (1-w_1)*dbeta(alpha_2, 1)

  METHARRAY <- matrix(data = 0, nrow = max_cov+1, ncol = max_cov+1)
  UNMETHARRAY <- matrix(data = 0, nrow = max_cov+1, ncol = max_cov+1)
  for (n in seq_len(max_cov+1)) {
    for (k in seq_len(n)) {
      UNMETHARRAY[n,k] <- gamlss.dist::dZIBB(x = k-1, mu = par_u['mu'], sigma = par_u['sigma'],
                                nu = par_u['nu'], bd = n-1)
      METHARRAY[n,k] <- gamlss.dist::dBB(x = k-1, mu = par_m['mu'], sigma = par_m['sigma'],
                            bd = n-1)
    }
  }
  rownames(METHARRAY) <- colnames(METHARRAY) <- 0:max_cov
  rownames(UNMETHARRAY) <- colnames(UNMETHARRAY) <- 0:max_cov

  return(list(METHARRAY = METHARRAY, UNMETHARRAY = UNMETHARRAY))
}

###### functions for computing emission probability ====


# Function for computing emission probability (1-grouping)
.calEmissionProb1Grp <- function(state_1g, total, meth, METHARRAY, UNMETHARRAY)
  ifelse(state_1g, METHARRAY[total+1, meth+1], UNMETHARRAY[total+1, meth+1])
# Compute emission probability (in 1-grouping case) of observing `meth` methylated read in `total` total reads
# `state_1g` is the binary code of underlying methylation states of the grouping: 1 - methylated; 0 - unmethylated.

# Tests:
# .calEmissionProb1Grp(state_1g = 1, total = 20, meth = 0, METHARRAY, UNMETHARRAY)
# .calEmissionProb1Grp(state_1g = 1, total = 20, meth = 10, METHARRAY, UNMETHARRAY)
# .calEmissionProb1Grp(state_1g = 1, total = 20, meth = 20, METHARRAY, UNMETHARRAY)
# sum(map_dbl(0:20, ~.calEmissionProb1Grp(state_1g = 0, total = 20, meth = .x, METHARRAY, UNMETHARRAY)))
# sum(map_dbl(0:20, ~.calEmissionProb1Grp(state_1g = 1, total = 20, meth = .x, METHARRAY, UNMETHARRAY)))


# Translates state_2g 0, 1 or 2 into binary grouping state vectors
.translateState2Grp <- function(state_2g){
  # Three states are encoded as: `0`->(0,0), `1`->(1,0), `2`->(1,1)
  state_2g <- as.integer(state_2g)
  # stopifnot("`state_2g` should be 0, 1 or 2." = state_2g %in% 0:2)
  group_state_vector <- c(0,0)
  if(state_2g %in% 1:2) group_state_vector[1] <- 1
  if(state_2g %in% 2) group_state_vector[2] <- 1
  return(group_state_vector)
}

# Compute expected methylated fraction, e.g. if pi1 = 0.7, (0,1) is translated to 0.3
.translateMethFrac2Grp <- function(state_2g, pi1){
  group_state_vector <- .translateState2Grp(state_2g)
  return(sum(group_state_vector*c(pi1, 1-pi1)))
}

.calEmissionProb2Grp <- function(state_2g, total, meth, pi1,
                                 CHOICEARRAY, METHARRAY, UNMETHARRAY){
  # Compute emission probability (in 2-grouping case) of observing `meth` methylated read in `total` total reads
  # `state_2g` is the integer code of underlying methylation states of the 2 groupings (`0` = (0,0), `1` = (1,0), `2` = (1,1)).
  # `pi1` is the prevalence of the methylated grouping

  max_cov <- nrow(CHOICEARRAY) - 1
  p <- .translateMethFrac2Grp(state_2g, pi1)
  # cat("state =", state_2g, "pi1 =", pi1, "p =", p, "\n") ## DEBUG
  prob <- 0
  for (i in 0:total) {
    for (j in 0:meth) {
      if (j <= i & meth-j <= total-i) {
        if (p < 0.0001 & i == 0) log_lik_1 <- 0
        else if (p > 0.9999 & i == total) log_lik_1 <- 0
        else log_lik_1 <- CHOICEARRAY[total+1, i+1] + i*log(p) + (total-i)*log(1-p)
        log_lik_2 <- log(METHARRAY[i+1, j+1]) + log(UNMETHARRAY[total-i+1, meth-j+1])
        log_lik_i_j <- log_lik_1 + log_lik_2
        prob <- prob + exp(log_lik_i_j)
      }
    }
  }
  return(prob)
}
# Tests:
# .calEmissionProb2Grp(state_2g = 0, total = 20, meth = 0, pi1, CHOICEARRAY, METHARRAY, UNMETHARRAY)
# .calEmissionProb2Grp(state_2g = 0, total = 20, meth = 10, pi1, CHOICEARRAY, METHARRAY, UNMETHARRAY)
# .calEmissionProb2Grp(state_2g = 0, total = 20, meth = 20, pi1, CHOICEARRAY, METHARRAY, UNMETHARRAY)
# sum(map_dbl(0:20, ~.calEmissionProb2Grp(state_2g = 0, total = 20, meth = .x, pi1, CHOICEARRAY, METHARRAY, UNMETHARRAY)))
# sum(map_dbl(0:20, ~.calEmissionProb2Grp(state_2g = 1, total = 20, meth = .x, pi1, CHOICEARRAY, METHARRAY, UNMETHARRAY)))
# sum(map_dbl(0:20, ~.calEmissionProb2Grp(state_2g = 2, total = 20, meth = .x, pi1, CHOICEARRAY, METHARRAY, UNMETHARRAY)))




# Function for loading transition probabilities from tp
.loadTransitProbs <- function(pos, all_probs = tp0@transit_probs)
  # `probs` should be a data.frame of 4 columns [P(0|0),P(0|1),P(1|0),P(1|1)], while row number represents CpG-CpG distance
  # `pos` is an atomic vector of genomic positions which shall be used to compute CpG-CpG distances and load transition probs
  all_probs[pmin(nrow(all_probs), diff(pos)), ]



###### Viterbi algorithm for 1- and 2-grouping cases =====
.Viterbi1Grp <- function(totals, meths, trans_probs, METHARRAY, UNMETHARRAY){
  if (any(c(length(totals), length(meths)) != nrow(trans_probs)+1))
    stop("Wrong dimensions of input data.")

  # Two states are encoded as: `0`->unmethylated, `1`->methylated
  state_nums <- 0:1
  num_cpg <- length(totals)

  # Memory used during Viterbi computation and for storing results
  V <- matrix(-Inf, nrow = num_cpg, ncol = 2) # for storing total log likelihood
  P <- matrix(-Inf, nrow = num_cpg, ncol = 2) # for storing transition and emission probs
  colnames(P) <- c("emission", "transition")
  traceback <- matrix(0, nrow = num_cpg, ncol = 2) # for storing tracebback pointers

  # Distribution of initial state is set to uniform (proportional to 1)
  for (i in seq_len(num_cpg)) {
    for (j in state_nums+1) {
      log_em_prob <- log(.calEmissionProb1Grp(state_1g = j-1,
                                              total = totals[i], meth = meths[i],
                                              METHARRAY, UNMETHARRAY))
      if (i == 1) { ## likelihood for the first CpG
        V[i, j] <- log_em_prob
        P[i, 'emission'] <- log_em_prob
        P[i, 'transition'] <- NA
      } else {
        best_prior_state <- 0
        for (j_prior in state_nums+1) {
          log_tr_prob <- log(trans_probs[i-1, j_prior+2*j-2])
          oldVal <- V[i,j]
          newVal <- log_em_prob + log_tr_prob + V[i-1, j_prior]
          if (oldVal < newVal) {
            V[i,j] <- newVal
            P[i, 'emission'] <- log_em_prob
            P[i, 'transition'] <- log_tr_prob
            best_prior_state <- j_prior - 1
          } else if (oldVal == newVal) { ## tie-breaking in Viterbi
            if (sample(0:1,1) == 0) best_prior_state <- j_prior - 1
          }
        }
        traceback[i,j] <- best_prior_state
      }
    }
  }
  # print(V); print(traceback)

  # Viterbi traceback
  state_path <- rep(0, num_cpg)
  loglik_path <- rep(-Inf, num_cpg)

  state_path[num_cpg] <- which.max(V[num_cpg,])-1
  loglik_path[num_cpg] <- max(V[num_cpg,])

  for (i in (num_cpg-1):1) {
    state_path[i] <- traceback[i+1, state_path[i+1]+1]
    loglik_path[i] <- V[i, state_path[i]+1]
  }
  return(data.frame(state_path, loglik_path, P))
}


.calTransProb2Grp <- function(i, trans_probs) {
  # Compute 2-group transition probability matrix for one CpG pair
  # All possible states in 2-group: (0,0), (1,0), (1,1)
  # Hence row/cols of prob mat for first grouping: 0, 1, 1; for second grouping: 0, 0, 1

  state1g_mat_grp1 <- matrix(c(0, 1, 1), nrow = 3, ncol = 3)
  state2g_mat_grp1 <- state1g_mat_grp1 + 2*t(state1g_mat_grp1) + 1

  state1g_mat_grp2 <- matrix(c(0, 0, 1), nrow = 3, ncol = 3)
  state2g_mat_grp2 <- state1g_mat_grp2 + 2*t(state1g_mat_grp2) + 1

  # Transition prob mat (rows = 'from', cols = 'to')
  prob_mat <- apply(state2g_mat_grp1, 1:2, function(j) trans_probs[i, j]) *
    apply(state2g_mat_grp2, 1:2, function(j) trans_probs[i, j])
  prob_mat <- prob_mat / rowSums(prob_mat) # Scale to normalized probs (each row adds up to 1)

  return(prob_mat)
}


.Viterbi2Grp <- function(totals, meths, trans_probs, pi1,
                         CHOICEARRAY, METHARRAY, UNMETHARRAY){
  # should be applied on 1 region
  # `trans_probs` should have four columns:  [P(0|0), P(0|1), P(1|0), P(1|1)]

  if (any(c(length(totals), length(meths)) != nrow(trans_probs)+1))
    stop("Wrong dimensions of input data.")

  # Three states are encoded as: `0`->(0,0), `1`->(1,0), `2`->(1,1)
  state_nums <- 0:2 # only allow three states
  num_group <- 2 # assuming 2 groupings
  num_cpg <- length(totals)

  # Memory used during Viterbi computation and for storing results
  V <- matrix(-Inf, nrow = num_cpg, ncol = 3) # for storing log likelihood
  P <- matrix(-Inf, nrow = num_cpg, ncol = 2) # for storing transition and emission probs
  colnames(P) <- c("emission", "transition")
  traceback <- matrix(0, nrow = num_cpg, ncol = 3) # for storing tracebback pointers

  # Distribution of initial state is set to uniform (proportional to 1)
  for (i in seq_len(num_cpg)) {

    # Compute transition prob matrix for 3-state model
    if(i > 1) tp_i_mat <- .calTransProb2Grp(i-1, trans_probs)

    for (j in state_nums+1) {
      log_em_prob <- log(.calEmissionProb2Grp(state_2g = j-1, total = totals[i], meth = meths[i],
                                              pi1, CHOICEARRAY, METHARRAY, UNMETHARRAY))
      if (i == 1) { ## likelihood for the first CpG
        V[i, j] <- log_em_prob
        P[i, 'emission'] <- log_em_prob
        P[i, 'transition'] <- NA
      } else {
        best_prior_state <- 0
        for (j_prior in state_nums+1) {

          # log_tr_prob <- 0
          # for (k in 1:num_group) {
          #   j_prior_bin <- .translateState2Grp(j_prior-1)[k]
          #   j_bin <- .translateState2Grp(j-1)[k]
          #   log_tr_prob <- log_tr_prob + log(trans_probs[i-1, j_prior_bin+2*j_bin+1])
          #   # cat("k = ", k, "; log_tr_prob = ", log_tr_prob, "\n")
          # }

          log_tr_prob <- log(tp_i_mat[j_prior, j])
          # cat(i, j, j_prior, exp(log_tr_prob), "\n") # DEBUG

          oldVal <- V[i,j]
          newVal <- log_em_prob + log_tr_prob + V[i-1, j_prior]
          if (oldVal < newVal){
            V[i,j] <- newVal
            P[i, 'emission'] <- log_em_prob
            P[i, 'transition'] <- log_tr_prob
            best_prior_state <- j_prior - 1
          }else if (oldVal == newVal){
            ## tie-breaking in Viterbi
            if (sample(0:1,1) == 0) best_prior_state <- j_prior - 1
          }
        }
        traceback[i,j] <- best_prior_state
        # cat(i, j, best_prior_state,"\n") # DEBUG
      }
    }
  }
  # print(V)
  # print(traceback)

  # Viterbi traceback
  state_path <- rep(0, num_cpg)
  bin_state_path <- matrix(0, nrow = num_cpg, ncol = 2)
  loglik_path <- rep(-Inf, num_cpg)

  state_path[num_cpg] <- which.max(V[num_cpg,])-1
  bin_state_path[num_cpg,] <- .translateState2Grp(state_path[num_cpg])
  loglik_path[num_cpg] <- max(V[num_cpg,])

  for (i in (num_cpg-1):1) {
    state_path[i] <- traceback[i+1, state_path[i+1]+1]
    bin_state_path[i, ] <- .translateState2Grp(state_path[i])
    loglik_path[i] <- V[i, state_path[i]+1]
  }

  colnames(bin_state_path) <- c("methState_group1", "methState_group2")
  return(data.frame(state_path, bin_state_path, loglik_path, P))
}
# Tests:
# pi1 = 0.5; N = 20
# pos = cumsum(sample(100:2000, 10))
# totals = sample(1:N, 10)
# trans_probs = .loadTransitProbs(pos = pos, all_probs = vmrseq:::tp0@transit_probs)
# meths = round(totals*0.5)
# REFARRAY <- .calRefArray(max_cov = N)
# CHOICEARRAY <- .calChoiceArray(REFARRAY)
# list <- .calMethArray(par_u = .priorParams(med_cov = round(median(totals)), type = "u"),
#                       par_m = .priorParams(med_cov = round(median(totals)), type = "m"),
#                       max_cov = N)
# METHARRAY <- list$METHARRAY; UNMETHARRAY <- list$UNMETHARRAY
# .Viterbi2Grp(totals, meths, trans_probs,
#              pi1, CHOICEARRAY, METHARRAY, UNMETHARRAY)
# .Viterbi1Grp(totals, meths, trans_probs, METHARRAY, UNMETHARRAY)


###### functions for prevalence optimization in 2-grouping case ====

# Function g_k(x) in the derivative of likelihood
.gradntFunc <- function(x, total, meth, CHOICEARRAY, METHARRAY, UNMETHARRAY) {
  numer <- 0
  denom <- 0
  for (i in 0:total) {
    for (j in 0:meth) {
      if (j <= i & meth-j <= total-i) {
        log_c_ijk <- CHOICEARRAY[total+1, i+1] + log(METHARRAY[i+1, j+1]) + log(UNMETHARRAY[total-i+1, meth-j+1])
        numer <- numer + exp(log_c_ijk + (i-1)*log(x) + (total-i-1)*log(1-x)) * (i-x*total)
        denom <- denom + exp(log_c_ijk + i*log(x) + (total-i)*log(1-x))
      }
    }
  }
  val <- - numer / denom
  return(val)
}

# Gradient of the log-likelihood with respect to (\pi_1, \pi_2)
.loglikGrad <- function(pi1, state_path, totals, meths, CHOICEARRAY, METHARRAY, UNMETHARRAY) {
  if (any(c(length(state_path), length(totals)) != length(meths)))
    stop("Wrong dimensions of input data.")

  grad1 <- 0#; grad2 <- 0 ## grad2 is always 0
  for (k in seq_along(state_path)) {
    state_2g <- state_path[k]
    total <- totals[k]
    meth <- meths[k]

    if (state_2g == 1) { ## Three states are encoded as: `0`->(0,0), `1`->(1,0), `2`->(1,1)
      p <- .translateMethFrac2Grp(state_2g, pi1)
      grad1 <- grad1 + .gradntFunc(p, total, meth, CHOICEARRAY, METHARRAY, UNMETHARRAY)
    }
  }
  return(grad1)
}

.prevOptimSnglInit <- function(pos, totals, meths, pi1_init, trans_probs,
                               epsilon = 1e-3, backtrack = TRUE, eta = ifelse(backtrack, 0.05, 0.005), max_iter = 200,
                               CHOICEARRAY, METHARRAY, UNMETHARRAY){
  # `tp` is an transitProbs object, which stores the transition probability distribution
  # `pi1_init` is the set initial value of \pi_1
  # `backtrack` is logical value indicating whether to use backtracking line search
  # `eta` is the learning rate (default: ifelse(backtrack, 0.05, 0.005))
  # `epsilon` is the convergence upper bound of \pi_1
  # `max_iter` is the maximum number of iteration
  # `eta` is the learning rate
  max_cov <- nrow(CHOICEARRAY) - 1

  pi_1 <- pi1_init; pi_2 <- 1 - pi_1
  init_vit <- .Viterbi2Grp(totals, meths, trans_probs, pi_1, CHOICEARRAY, METHARRAY, UNMETHARRAY)
  state_path <- init_vit$state_path
  old_loglik <- loglik <- init_vit$loglik_path[nrow(init_vit)]

  for (t in seq_len(max_iter)) {
    # print(t) # DEBUG
    old_pi_1 <- pi_1

    ## EG update (Experimented with unit test: slower when momentum is added)
    pi_2 <- 1 - pi_1
    grad <- .loglikGrad(pi_1, state_path, totals, meths, CHOICEARRAY, METHARRAY, UNMETHARRAY)

    # Decrease learning rate (eta) if updated pi_1 goes to 0 or 1
    try_pi_1 <- pi_1 * exp(-eta*grad)
    try_pi_1 <- try_pi_1 / (try_pi_1 + pi_2)
    # print(try_pi_1) # DEBUG
    while (try_pi_1 < 0.01 | try_pi_1 > 0.99) {
      eta <- 0.1 * eta
      try_pi_1 <- pi_1 * exp(-eta*grad)
      try_pi_1 <- try_pi_1 / (try_pi_1 + pi_2)
      # print(try_pi_1) # DEBUG
    }

    # Viterbi update
    vit <- .Viterbi2Grp(totals, meths, trans_probs, try_pi_1, CHOICEARRAY, METHARRAY, UNMETHARRAY)
    if (vit$loglik_path[nrow(init_vit)] <= loglik) { # decrease learning rate if likelihood does NOT increase
      eta <- 0.5 * eta
      try_pi_1 <- pi_1 * exp(-eta*grad)
      try_pi_1 <- try_pi_1 / (try_pi_1 + pi_2)
      pi_1 <- try_pi_1
    } else { # only adopt updated pi if likelihood increases
      old_loglik <- loglik
      loglik <- vit$loglik_path[nrow(init_vit)]
      state_path <- vit$state_path
      pi_1 <- try_pi_1
      if(backtrack) { # backtracking line search
        alpha <- 0.5; beta <- 0.7
        if(loglik > old_loglik - alpha*eta*grad^2) eta <- beta*eta
      }
    }

    # cat(pi_1, loglik, "\n") # DEBUG
    # if(t == max_iter) print("Max iteration achieved.")
    if(abs(loglik - old_loglik) < epsilon & abs(old_pi_1 - pi_1) < epsilon) break
  }

  return(list(pi1_init = pi1_init, optim_pi_1 = pi_1, vit_path = vit[, -1], loglik = loglik, n_iter = t))
}



###### wrapper for 1- and 2-group optimization ======

.solve1Grp <- function(pos, totals, meths, tp, METHARRAY, UNMETHARRAY) {
  trans_probs <- .loadTransitProbs(pos = pos, all_probs = tp@transit_probs)
  vit <- .Viterbi1Grp(totals, meths, trans_probs, METHARRAY, UNMETHARRAY)
  return(list(vit_path = vit, loglik = vit[nrow(vit), 'loglik_path']))
}

.solve2Grp <- function(gradient,
                       pos, totals, meths, tp,
                       inits, epsilon, backtrack,
                       eta, max_iter,
                       CHOICEARRAY, METHARRAY, UNMETHARRAY){

  trans_probs <- .loadTransitProbs(pos = pos, all_probs = tp@transit_probs)

  if (gradient) {
    loglik <- -Inf; optim_pi_1 <- -1
    for (i in seq_along(inits)) {
      # cat(i, "\n") # DEBUG
      pi1_init <- inits[i]
      res_temp <- .prevOptimSnglInit(pos, totals, meths, pi1_init, trans_probs,
                                     epsilon, backtrack, eta, max_iter,
                                     CHOICEARRAY, METHARRAY, UNMETHARRAY)
      if (res_temp$loglik > loglik) {
        loglik <- res_temp$loglik
        res <- res_temp
        optim_pi_1 <- res$optim_pi_1
      }
    }
  } else {
    loglik <- -Inf
    for (i in seq_along(inits)) {
      pi1 <- inits[i]
      vit <- .Viterbi2Grp(totals, meths, trans_probs, pi1,
                          CHOICEARRAY, METHARRAY, UNMETHARRAY)
      if (vit$loglik_path[nrow(vit)] > loglik) {
        loglik <- vit$loglik_path[nrow(vit)]
        res <- list("pi1_init" = pi1,
                    "optim_pi_1" = pi1,
                    "vit_path" = vit[, -1],
                    "loglik" = vit$loglik_path[nrow(vit)],
                    "n_iter" = 0)
      }
    }
  }
  return(res)
}

# Tests:
# pos = cumsum(sample(2:500, 100))
# totals = sample(5:20, 100, replace = T)
# meths = round(totals*runif(length(pos), 0.1, 0.9))
# REFARRAY <- .calRefArray(max_cov = max(totals))
# CHOICEARRAY <- .calChoiceArray(REFARRAY)
# list <- .calMethArray(par_u = .priorParams(med_cov = round(median(totals)), type = "u"),
#                       par_m = .priorParams(med_cov = round(median(totals)), type = "m"),
#                       max_cov = N)
# METHARRAY <- list$METHARRAY; UNMETHARRAY <- list$UNMETHARRAY
# .solve1Grp(pos, totals, meths, tp0, METHARRAY, UNMETHARRAY)
# .solve2Grp(pos, totals, meths, inits = c(.2,.5,.8), tp0,
#            epsilon = 1e-3, backtrack = T,
#            eta = ifelse(backtrack, 0.05, 0.005), max_iter = 200,
#            CHOICEARRAY, METHARRAY, UNMETHARRAY)


### functions for detect VMRs in predicted state sequence
# .callVMR <- function(state_seq_2g, min_n, max_n_merge){ # Not merging all VMRs in a CR
#
#   state_seq_2g <- as.data.frame(state_seq_2g) # Formatting
#
#   is_vml <- as.logical(abs(state_seq_2g[[1]] - state_seq_2g[[2]]))
#   len <- length(is_vml)
#
#   i <- j <- 1; start_ind <- end_ind <- NULL
#   while (j <= len) {
#     if (i==j) { # either i,j are non-VML or start of a VMR
#       if (is_vml[i]) {
#         start_ind <- c(start_ind, i)
#         if (j == len) end_ind <- c(end_ind, j)
#         j <- j + 1
#       } else {
#         i <- j <- j + 1
#       }
#     } else { # i at start of VMR, j goes to end of VMR
#       if (is_vml[j]) {
#         if (j == len) end_ind <- c(end_ind, j)
#         j <- j + 1
#       } else {
#         if (j + max_n_merge <= len & is_vml[j + max_n_merge]) {
#           j <- j + max_n_merge
#         } else {
#           end_ind <- c(end_ind, j-1)
#           i <- j <- j + max_n_merge + 1
#         }
#       }
#       # if (j == len) end_ind <- c(end_ind, j)
#     }
#   }
#
#   if (length(start_ind) != length(end_ind))
#     stop("Unmatched length of start_ind and end_ind.")
#   inds <- data.frame(start_ind = start_ind, end_ind = end_ind)
#   if (nrow(inds) > 0) inds <- inds %>% filter(end_ind - start_ind + 1 >= min_n)
#   if (nrow(inds) == 0) inds <- NULL
#   return(inds)
# }
.callVMR <- function(state_seq_2g, min_n){ # Merge all VMRs with more than `min_n` CpGs in a CR

  state_seq_2g <- as.data.frame(state_seq_2g) # Formatting
  is_vml <- as.logical(abs(state_seq_2g[[1]] - state_seq_2g[[2]]))
  if (!any(is_vml)) return(NULL)

  # Find all VMRs regardless of number of CpGs
  len <- length(is_vml); start_ind <- end_ind <- NULL
  if (is_vml[1]) start_ind <- c(start_ind, 1)
  start_ind <- c(start_ind, which(is_vml & !lag(is_vml)))
  end_ind   <- c(end_ind,   which(!is_vml & lag(is_vml)))
  if (is_vml[len]) end_ind <- c(end_ind, len)

  # Sanity check
  if (length(start_ind) != length(end_ind)) stop("Unmatched length of start_ind and end_ind.")

  # Merge all VMRs >= `min_n` CpGs in this CR
  inds <- data.frame(start_ind = start_ind, end_ind = end_ind)
  if (nrow(inds) > 0) inds <- inds %>% dplyr::filter(end_ind - start_ind + 1 >= min_n) # remove VMRs with < `min_n` CpGs
  if (nrow(inds) > 0) inds <- with(inds, data.frame(start_ind = start_ind[1], end_ind = end_ind[length(end_ind)])) # merge
  if (nrow(inds) == 0) inds <- NULL
  return(inds)
}

#' Plot transition probability distribution
#'
#' @param tp 'transitProbs' object storing information about trained transition
#' probabilities. Can be obtained from function `estimTransitProbs`
#' @param line_size size of fitted loess smooth line. Default value is 0.2.
#' @param plot_train logical value indiating whether to plot training data.
#' Default is TRUE.
#' @param point_size size of training data points. Only applicable when
#' `plot_train = T`. Default value is 0.2.
#'
#'
#' @import ggplot2
#' @importFrom dplyr %>%
#' @importFrom stats na.omit var
#' @importFrom tidyr pivot_longer
#'
#' @return A plot of the transition probability distribution
#' @export
#'
#' @examples
#' tpPlot(vmrseq:::tp0)
#' 
tpPlot <- function(tp,
                    line_size = 0.2,
                    plot_train = TRUE,
                    point_size = 0.2) {

  # compatibility checks within transProbs object
  if(nrow(tp@transit_probs) != tp@max_dist_bp)
    stop("Number of rows in `transit_probs` not equal to `maxdist_bp`.")
  if(nrow(tp@buffer_probs) != tp@buffer_bp)
    stop("Number of rows in `buffer_probs` not equal to `buffer_bp`.")
  if(nrow(tp@transit_probs) + nrow(tp@buffer_probs) != nrow(tp@train))
    stop("Number of rows in `transit_probs` and `buffer_probs` not adding up to number of rows in `train`.")

  plot_df <-
    data.frame(
      dist_bp = 1:nrow(tp@train),
      rbind(tp@transit_probs, tp@buffer_probs),
      tp@train
    ) %>%
    tidyr::pivot_longer(
      cols = -1,
      names_to = c(".value", "type"),
      names_pattern = "(.*)_(.*)"
    )

  type_labs <- c("P(0|0)","P(0|1)","P(1|0)","P(1|1)")
  names(type_labs) <- c("00","01","10","11")

  if (plot_train) {
    plot_df %>%
      ggplot() +
      geom_ribbon(aes(dist_bp, ymin = pbar-sqrt(var), ymax = pbar+sqrt(var)),
                  fill = "lightblue", size = point_size, alpha = 0.4) +
      geom_point(aes(dist_bp, pbar), color = "grey", size = point_size) +
      geom_vline(xintercept = tp@max_dist_bp, color = "light blue", linetype = "dashed") +
      geom_path(aes(dist_bp, phat), color = "red", size = line_size) +
      theme_bw() + ylim(0, 1) +
      xlab("CpG-CpG Distance") + ylab("Transition Probability") +
      facet_wrap(~ type, labeller = labeller(type = type_labs))
  } else {
    plot_df %>%
      ggplot() +
      geom_path(aes(dist_bp, phat), color = "red", size = line_size) +
      geom_vline(xintercept = tp@max_dist_bp, color = "light blue", linetype = "dashed") +
      theme_bw() + ylim(0, 1) +
      xlab("CpG-CpG Distance") + ylab("Transition Probability") +
      facet_wrap(~ type, labeller = labeller(type = type_labs))
  }
}

#' @title Construct candidate regions and detect variably methylated regions.
#'
#' @description Construct candidate regions (CRs) by taking groups of consecutive loci that exceed
#' threshold on the variance of smoothed relative methylation levels and detect
#' variably methylated regions (VMRs) by optimizing a hidden Markov model (HMM).
#'
#' @param gr \code{GRanges} object output by \code{vmrseq::vmrseqSmooth},
#' containing genomic coordinates (chr, start, end) and summarized information
#' (meth, total, var) of CpG sites in the input dataset.
#' @param alpha positive scalar value between 0 and 1 that represents the
#' designated significance level for determining variance threshold of candidate
#' regions construction. The variance threshold is determined by taking 1-alpha
#' quantile value of an approximate null distribution of variance simulated
#' from the beta priors of emission probability in the hidden Markov model.
#' Default value of alpha is 0.05.
#' @param maxGap integer value representing maximum number of base pairs in
#' between neighboring CpGs to be included in the same VMR. Default value is
#' 2000 bp.
#' @param stage1only boolean value indicating whether the algorithm should run
#' stage 1 of vmrseq (the construction of candidate regions) only. If set to TRUE,
#' the function will output only the candidate regions. Default is FALSE.
#' @param minNumCR positive integer value representing the minimum number of
#' CpG sites within a candidate region. Default value is 5.
#' @param minNumVMR positive integer value representing the minimum number of
#' CpG sites within a variably methylated region. Default value is 5.
#' @param gradient logical value indicating whether exponentiated gradient
#' descent shall be applied to update prevalence parameter. Default is TRUE. If
#' set as FALSE, initial values (i.e., value of \code{inits} arguments in
#' \code{vmrsqe::vmrseqOptimControl}, can be set up in the \code{control}
#' argument of this function) are used as prevalence parameter for decoding
#' hidden states.
#' @param tp a `transitProbs-class` object that contains the transition
#' probability distribution used for HMM optimization. Default value is
#' transition probability \code{vmrseq:::tp0} built in the package that was
#' previously trained on mouse brain cells. See manuscript for training
#' procedure and data source.
#' @param control list of miscellaneous parameters used to control optimization
#' of the HMM model. Default is output of \code{vmrseq::vmrseqOptimControl()}.
#' Can be changed by tweaking arguments in function \code{vmrseq::vmrseqOptimControl()}.
#' @param verbose logical value that indicates whether progress messages
#' should be printed to stdout. Defaults value is TRUE.
#' @param BPPARAM a \code{BiocParallelParam} object to specify the parallel
#' backend. The default option is \code{BiocParallel::bpparam()} which will
#' automatically creates a cluster appropriate for the operating system.
#' @importFrom BiocParallel bplapply register MulticoreParam bpparam
#' @importFrom bumphunter clusterMaker getSegments
#' @importFrom gamlss.dist rBEZI rBE
#' @importFrom dplyr filter
#' @import GenomicRanges
#'
#' @return The results object is a list of 6 elements that contains the following information:
#' 1. `gr`: The `Granges` object that has been input to `vmrseqFit` with two added metadata columns:
#'     + `cr_index` = Index in reference to rows of `cr.ranges`, denoting row number of the candidate region to which the CpG site belongs.
#'     + `vmr_index` = Index in reference to rows of `vmr.ranges`, denoting row number of the variably methylated region to which the CpG site belongs.
#' 2. `vmr.ranges`: A `Granges` object with the coordinates of each detected variably methylated region (each row is a VMR), with metadata columns:
#'     + `num_cpg` = Number of observed CpG sites in the VMR.
#'     + `start_ind` = Index of the starting CpG sites in reference to rows of `gr`.
#'     + `end_ind` = Index of the ending CpG sites in reference to rows of `gr`.
#'     + `pi` = Prevalence of the methylated grouping (see manuscript for details)
#'     + `loglik_diff` = Difference in log-likelihood of two-grouping and one-grouping HMM fitted to the VMR; can be used to rank the VMRs.
#' 3. `cr.ranges`: A `Granges` object with the coordinates of each candidate region (each row is a candidate region), with metadata column:
#'     + `num_cpg` = Number of observed CpG sites in the candidate region.
#' 4. `alpha`: Designated significance level (default 0.05, can be changed by user with function argument). It is used for determining the threshold on variance used for constructing candidate. The threshold is computed by taking the (1-alpha) quantile of an approximate null distribution of variance (see manuscript for details).
#' 5. `var_cutoff`: Variance cutoff computed from `alpha`.
#' 6. `bb_params`: Beta-binomial parameter used in emission probability of the HMM model; they are determined by the magnitude of the input dataset (see manuscript for details).
#'
#' @export
#' 
#' @examples
#' # load example data
#' data(toy.gr)
#' # run vmrseqFit
#' toy.results <- vmrseqFit(toy.gr)
#' toy.results
#'
vmrseqFit <- function(
    gr,
    alpha = 0.05,
    maxGap = 2000,
    stage1only = FALSE,
    minNumCR = 5,
    minNumVMR = 5,
    gradient = TRUE,
    tp = NULL,
    control = vmrseqOptimControl(),
    verbose = TRUE,
    BPPARAM = BiocParallel::bpparam()
) {

  # Register the parallel backend
  BiocParallel::register(BPPARAM)
  backend <- paste0("BiocParallel:", class(bpparam())[1])
  if (bpparam()$workers == 1) {
    if (verbose) {
      mes <- "Parallel: Using a single core (backend: %s)."
      message(sprintf(mes, backend))
    }
    parallel <- FALSE
  } else {
    if (verbose) {
      mes <- "Parallel: Parallelizing using %s workers/cores (backend: %s)."
      message(sprintf(mes, bpparam()$workers, backend))
    }
    parallel <- TRUE
  }

  # Compute cutoff from beta priors
  pars <- getPriorParams(gr$total)
  cutoff <- computeVarCutoff(
    alpha = alpha,
    meth = gr$meth,
    total = gr$total,
    pars_u =  pars$pars_u,
    pars_m = pars$pars_m
  )

  # Bumphunt candidate regions
  message("Step 1: Detecting candidate regions...")
  CRI <- callCandidRegion(
    gr = gr,
    cutoff = cutoff,
    maxGap = maxGap,
    minNumCR = minNumCR,
    bpWindow = bpWindow,
    verbose = verbose,
    parallel = parallel
  ) # Outputs list of index vectors. Each list element contains indices in of a CR `gr`.

  if (is.null(CRI)) { # End the function if no CR detected
    message("...No candidate regions pass the cutoff")
    return(NULL)
  } else {
    pct_incr <- round(sum(lengths(CRI))/length(gr)*100, 2)
    message("...Finished calling candidate regions - found ", length(CRI),
            " candidate regions in total.
  ...", pct_incr,
            "% sites are called to be in candidate regions.")

    # Add summary stats (smoothed var and CR index) into output
    cr_index <- rep(NA, length(gr))
    cr_index[unlist(CRI)] <- rep.int(1:length(CRI), lengths(CRI))
    values(gr)$cr_index <- cr_index

    cr.gr <- indexToGranges(gr = gr, Indexes = CRI)

    if (stage1only) {
      return(list(gr = gr, cr.ranges = cr.gr, alpha = alpha, var_cutoff = cutoff))
    } else {
      # Starting detecting VMRs
      message(
        "Step 2: Detecting VMRs..."
      )
      t1 <- proc.time()

      vmr.df <- searchVMR( # data frame of VMR information
        gr = gr,
        CRI = CRI,
        minNumVMR = minNumVMR,
        tp = tp,
        gradient = gradient,
        control = control,
        verbose = verbose,
        parallel = parallel
      )
      VMRI <- lapply( # list of indices of VMRs
        1:nrow(vmr.df),
        function(i) vmr.df$start_ind[i]:vmr.df$end_ind[i]
      )

      t2 <- proc.time()

      if (nrow(vmr.df) == 0) {
        message("No VMR detected.")
        return(NULL)
      } else {
        message("...Finished detecting VMRs - took ",
                round((t2 - t1)[3]/60, 2), " min and ",
                nrow(vmr.df), " VMRs found in total.
  ...", round(sum(vmr.df$end_ind-vmr.df$start_ind+1) / length(gr) * 100, 2),
                "% sites are called to be in VMRs.")
      }

      # Formatting function output
      vmr_index <- rep(NA, length(gr))
      vmr_index[unlist(VMRI)] <- rep.int(1:length(VMRI), lengths(VMRI))
      values(gr) <- cbind(values(gr), vmr_index)

      vmr.gr <- indexToGranges(gr = gr, Indexes = VMRI)
      values(vmr.gr) <- cbind(values(vmr.gr), vmr.df[, -c(3,5)])
      return(list(gr = gr, vmr.ranges = vmr.gr, cr.ranges = cr.gr, alpha = alpha, var_cutoff = cutoff, bb_params = pars))
    }
  }
}

#' Estimate transition probilities conditioning on CpG-CpG distance
#'
#' @description This function first computes transition probilities
#' conditioning on CpG-CpG distance in each cell. Then the probs from
#' individual cells are smoothed over CpG-CpG distance using `loess`
#' with inverse-variance fitting.
#'
#' @param list a list of data.frame objects. Each data.frame
#' contains information of 1 unit of training data (can be a cell or a
#' subtype) and should have 3 columns in strict rder of: (chr), (pos),
#' (binary methyl value). Column names are not necessary.
#' @param max_dist_bp positive integer value indicating the maximum
#' CpG-CpG distance in base pairs before the transition probabilities
#' reach constant value. Default value is 2000.
#' @param buffer_bp length of buffer in base pairs used to fit smoothing
#' curve near maximum distance and plot diagnostics. Default is 3000.
#' @param lags a vector indicating possible number of lagged CpGs for
#' estimation of transition probabilities.
#' @param BPPARAM a \code{BiocParallelParam} object to specify the parallel
#' backend. The default option is \code{BiocParallel::bpparam()} which will
#' automatically creates a cluster appropriate for the operating system.
#' @param degree 'degree' argument for `loess` function
#' @param span 'span' argument for `loess` function
#' @param ... additional arguments passed into the `loess` function.
#'
#' @return a 'transitProbs' object. Postfixes rule in the output variables:
#' P(0|0) => '00'; P(0|1) => '01'; P(1|0) => '10'; P(1|1) => '11'.
#'
#' @importFrom dplyr %>% mutate lag ungroup select filter group_by summarise right_join arrange
#' @importFrom methods new
#' @importFrom stats loess
#' @importFrom BiocParallel bplapply register MulticoreParam bpparam
#'
#' @export
#' 
#' @examples
#' 
#' # load example data
#' data(cell_1, cell_2, cell_3)
#' 
#' # process the data to align with input format
#' library(dplyr)
#' df_1 <- cell_1 %>% mutate(meth = round(mc_count / total)) %>% select(chr, pos, meth)
#' df_2 <- cell_2 %>% mutate(meth = round(mc_count / total)) %>% select(chr, pos, meth)
#' df_3 <- cell_3 %>% mutate(meth = round(mc_count / total)) %>% select(chr, pos, meth)
#' 
#' # run tpEstimate
#' list <- list(df_1, df_2, df_3)
#' tpEstimate(list)
#'
tpEstimate <- function(list,
                        max_dist_bp = 2000,
                        buffer_bp = 3000,
                        lags = 1:10,
                        BPPARAM = bpparam(),
                        degree = 2, span = 0.02,
                        ...) {

  # Register the parallel backend
  BiocParallel::register(BPPARAM)
  backend <- paste0("BiocParallel:", class(bpparam())[1])

  for (i in length(list)) {
    list[[i]] <- list[[i]] %>% na.omit()
    if(!all(unlist(list[[i]][,3]) %in% 0:1))
      stop("Methylation value should be either integer 0 or 1.")
  }

  if (bpparam()$workers == 1) {
    mes <- "Using a single core (backend: %s)."
    message(sprintf(mes, backend))
    parallel <- FALSE
  } else {
    mes <- paste0("Parallelizing using %s workers/cores ",
                  "(backend: %s).")
    message(sprintf(mes, bpparam()$workers, backend))
    parallel <- TRUE
  }

  message("Computing transition probs within training unit.")
  # Proportions of sites in categories 00, 01, 10, 11 conditioning on
  # CpG distance
  if (parallel) {
    smr_units <- do.call(
      rbind,
      list %>% BiocParallel::bplapply(.computeProb1Unit,
                                      max_dist_bp = max_dist_bp,
                                      buffer_bp = buffer_bp,
                                      lags = lags)
    )
  } else {
    smr_units <- do.call(
      rbind,
      list %>% lapply(.computeProb1Unit,
                      max_dist_bp = max_dist_bp,
                      buffer_bp = buffer_bp,
                      lags = lags)
    )
  }

  return(
    .estimTransitProbsFromSummary(
      smr_units = smr_units,
      max_dist_bp = max_dist_bp, buffer_bp = buffer_bp,
      degree = degree, span = span,
      parallel = parallel, ...
    )
  )
}

# compute probs in one training unit
.computeProb1Unit <- function(df, max_dist_bp, buffer_bp, lags){

  colnames(df) <- c("chr", "pos", "state")

  .computeLag <- function(lag) {
    lag_df <- df %>%
      group_by(chr) %>%
      dplyr::mutate(state_lag = dplyr::lag(state, n = lag),
                    dist_bp = c(rep(NA, lag), diff(pos, lag = lag))) %>%
      dplyr::ungroup() %>%
      dplyr::select(state, state_lag, dist_bp) %>%
      dplyr::filter(dist_bp <= max_dist_bp + buffer_bp) %>%
      group_by(dist_bp) %>%
      summarise(N_00 = sum(state == 0 & state_lag==0), # number of sites from 0 to 0
                N_10 = sum(state == 1 & state_lag==0), # number of sites from 0 to 1
                N_01 = sum(state == 0 & state_lag==1), # number of sites from 1 to 0
                N_11 = sum(state == 1 & state_lag==1)  # number of sites from 1 to 1
      )
    return(lag_df)
  }

  smr_df <- do.call(rbind, lapply(lags, .computeLag)) %>%
    dplyr::group_by(dist_bp) %>%
    dplyr::summarise(N_00 = sum(N_00), # number of sites from 0 to 0
                     N_10 = sum(N_10), # number of sites from 0 to 1
                     N_01 = sum(N_01), # number of sites from 1 to 0
                     N_11 = sum(N_11)  # number of sites from 1 to 1
    ) %>%
    dplyr::mutate(p_00 = N_00 / (N_00 + N_10), # P(X_i = 0 | X_{i-1} = 0)
                  p_01 = N_01 / (N_01 + N_11) # P(X_i = 0 | X_{i-1} = 1)
    ) %>%
    dplyr::mutate(p_10 = 1 - p_00, # P(X_i = 1 | X_{i-1} = 0)
                  p_11 = 1 - p_01 # P(X_i = 1 | X_{i-1} = 1)
    ) %>%
    # dplyr::select(-c(N_00, N_10, N_01, N_11)) %>%
    dplyr::right_join(data.frame(dist_bp = 1:(max_dist_bp+buffer_bp)), by = "dist_bp") %>%
    dplyr::arrange(dist_bp)

  return(smr_df)
}

# loess fitting from cell-level summary data
.estimTransitProbsFromSummary <- function(smr_units, max_dist_bp, buffer_bp, degree, span, ...){

  stopifnot("max(smr_units$dist_bp) not equal to max_dist_bp + buffer_bp." =
              max(smr_units$dist_bp) == max_dist_bp + buffer_bp)

  message("Computing mean and var of the probs across cells.")
  train_data <- smr_units %>%
    dplyr::filter(dist_bp > 0) %>%
    dplyr::group_by(dist_bp) %>%
    dplyr::summarise(pbar_00 = mean(p_00, na.rm = TRUE),
              pbar_01 = mean(p_01, na.rm = TRUE),
              pbar_10 = mean(p_10, na.rm = TRUE),
              pbar_11 = mean(p_11, na.rm = TRUE),
              var_00 = var(p_00, na.rm = TRUE),
              var_01 = var(p_01, na.rm = TRUE),
              var_10 = var(p_10, na.rm = TRUE),
              var_11 = var(p_11, na.rm = TRUE)) %>%
    # dplyr::add_row(dist_bp = 1,
    #         pbar_00 = NA, pbar_01 = NA, pbar_10 = NA, pbar_11 = NA,
    #         var_00 = NA, var_01 = NA, var_10 = NA, var_11 = NA,
    #         .before = 1) %>%
    dplyr::right_join(data.frame(dist_bp = 1:(max_dist_bp+buffer_bp)), by = "dist_bp")

  message("Loess smoothing over probs.")

  .selectCols <- function(subscript) {
    # 'subscript' should be one of the strings '00', '01', '10', '11'
    train_cols <- train_data %>%
      dplyr::select(dist_bp,
                    paste0("pbar_", subscript),
                    paste0("var_", subscript)) %>%
      dplyr::filter(eval(parse(text = paste0("var_", subscript))) > 0)
    return(train_cols)
  }

  x <- 1:(max_dist_bp+buffer_bp) # starting from 1 so that row number equal to distance
  smoothed_probs <- data.frame(
    phat_00 = with(
      .selectCols('00'),
      loess(pbar_00 ~ log(dist_bp), weights = 1/var_00, degree = degree, span = span, ...) %>%
        predict(newdata = log(x))
    ),
    phat_01 = with(
      .selectCols('01'),
      loess(pbar_01 ~ log(dist_bp), weights = 1/var_01, degree = degree, span = span, ...) %>%
        predict(newdata = log(x))
    ),
    phat_10 = with(
      .selectCols('10'),
      loess(pbar_10 ~ log(dist_bp), weights = 1/var_10, degree = degree, span = span, ...) %>%
        predict(newdata = log(x))
    ),
    phat_11 = with(
      .selectCols('11'),
      loess(pbar_11 ~ log(dist_bp), weights = 1/var_11, degree = degree, span = span, ...) %>%
        predict(newdata = log(x))
    )
  )

  tp <- new("transitProbs",
            max_dist_bp = max_dist_bp, buffer_bp = buffer_bp,
            transit_probs = smoothed_probs[1:max_dist_bp,],
            buffer_probs = smoothed_probs[(1:buffer_bp)+max_dist_bp,],
            train = train_data %>% dplyr::select(-dist_bp))
  return(tp)
}

#' @title Smoothing on single-cell bisulfite sequencing data for the purpose of
#' constructing candidate regions.
#'
#' @description \code{vmrseqSmooth} takes a \code{SummarizedExperiment} object
#'  with information of methylation level of individual cells as input, and
#'  perform a kernel smoother to ‘relative’ methylation levels of individual
#'  cells prior to constructing candidate regions. Purpose of the smoothing is
#'  to adjust for uneven coverage biases and borrow information from nearby sites.
#'  See manuscript for detailed description.
#'
#' @param SE \code{SummarizedExperiment} object with one (and only one) assay that
#'  contains *binary* methylation status of CpG sites in individual cells. We
#'  recommend using output by \code{\link{poolData}} (i.e., an NA-dropped
#'  HDF5-based SummarizedExperiment object) to prevent running out of memory.
#' @param bpWindow positive integer that represents the width (in bp) of
#'  smoothing window. Default value is 2000.
#' @param sparseNAdrop logical value that represents whether the NA values are
#'  droppped in the input \code{SE} object. \code{SE} objects output by
#'  \code{\link{poolData}} are NA dropped. See \code{?vmrseq::poolData}
#'  for details about NA-dropped representation.
#' @param verbose logical value that indicates whether progress messages
#'  should be printed to stdout. Defaults value is TRUE.
#' @param BPPARAM a \code{BiocParallelParam} object to specify the parallel
#'  backend. The default option is \code{BiocParallel::bpparam()} which will
#'  automatically creates a cluster appropriate for the operating system.
#'
#' @importFrom BiocParallel bplapply register MulticoreParam bpparam
#' @importFrom stats fitted median
#' @importFrom gamlss.dist dZIBB dBB
#' @importFrom locfit locfit lp
#' @importFrom DelayedArray rowSums colSums rowMeans colMeans is_sparse
#' @importFrom recommenderlab dropNA2matrix
#' @import GenomicRanges
#' @import SummarizedExperiment
#'
#' @return a \code{GRanges} object that contains the result of smoothing.
#'  The object retains genomic coordinates (chr, start, end) of input CpG
#'  sites, in the same order as in the input \code{SE} object. Three
#'  column are added (on top of original metadata columns for the CpG sites in
#'  \code{SE}, if any):
#'  1. meth: methylated cell count of the CpG
#'  2. total: total (non-missing) cell count of the CpG
#'  3. var: variance computed based on individual-cell smoothed relative methylation levels.
#'
#' @seealso \code{\link{poolData}}, \code{\link{vmrseqFit}}
#' @export
#' 
#' @examples
#' # load example data
#' toy.se <- HDF5Array::loadHDF5SummarizedExperiment(system.file("extdata", "toy", package = "vmrseq"))
#' 
#' # preprocessing
#' total <- DelayedArray::rowSums(SummarizedExperiment::assays(toy.se)$M_mat > 0)
#' toy.se <- subset(toy.se, total >= 3)
#' 
#' # run vmrseqSmooth
#' toy.gr <- vmrseqSmooth(toy.se)
#' toy.gr
#'
vmrseqSmooth <- function(
    SE,
    bpWindow = 2000, # param for individual-cell methylation residual smoother
    sparseNAdrop = is_sparse(assays(SE)[[1]]),
    verbose = TRUE, BPPARAM = bpparam()
) {

  # Params for across-cell mean methylation smoother (for experimental purpose)
  meanSmooth <- FALSE # turning off meanSmooth works better in practice
  bpSpan <- 0; minInSpan <- 0

  if (meanSmooth & bpSpan<=0 & minInSpan<=0)
    stop("If mean methylation need to be smoothed, at least one of 'bpSpan' and 'minInSpan' should be positive (integer) number.")

  for (chromosome in unique(seqnames(SE))) {
    SE_chr <- subset(SE, seqnames(SE) == chromosome)
    if (min(diff(start(SE_chr))) < 2)
      stop("There exists at least 2 rows with position difference less than 2 bp.")
  }


  # TODO: remove sites with total_read = 0
  # TODO: report data dimensions

  gr <- granges(SE)
  M <- assays(SE)[[1]]

  if (!sparseNAdrop) {
    values(gr)$meth <- rowSums(M, na.rm = TRUE)
    values(gr)$total <- rowSums(M >= 0, na.rm = TRUE)
  } else {
    values(gr)$meth <- as.integer(round(rowSums(M)))
    values(gr)$total <- rowSums(M > 0)
  }

#
#   if (min(values(gr)$total) < 3)
#     warning("We suggest removing CpG sites with across-cell coverage lower than 3 before running vmrseq.")

  # Register the parallel backend
  BiocParallel::register(BPPARAM)
  backend <- paste0("BiocParallel:", class(bpparam())[1])
  if (bpparam()$workers == 1) {
    if (verbose) {
      mes <- "Parallel: Using a single core (backend: %s)."
      message(sprintf(mes, backend))
    }
    parallel <- FALSE
  } else {
    if (verbose) {
      mes <- "Parallel: Parallelizing using %s workers/cores (backend: %s)."
      message(sprintf(mes, bpparam()$workers, backend))
    }
    parallel <- TRUE
  }

  # Smoothing starts
  message("Smoothing in progress...")

  # Apply smoother and compute variance on each chromosome serially
  meanMeth <- NULL; var <- NULL
  chrs <- as.character(unique(seqnames(gr)))
  for (chromosome in chrs) {
    if (verbose) message("...Chromosome ",
                         paste(chromosome, collapse = ", "), ": ",
                         appendLF = FALSE)

    t1 <- proc.time() # time point 1
    gr_chr <- subset(gr, seqnames(gr) == chromosome)
    M_chr <- M[seqnames(gr) == chromosome, ]

    # smooth on fractional methylation if meanSmooth==TRUE
    origin_mean_chr <- gr_chr$meth / gr_chr$total
    if (meanSmooth) {
      fit_chr <- smoothMF(x = start(gr_chr), y = origin_mean_chr,
                          chr = chromosome,
                          weights = gr_chr$total, # across-cell coverage as weights
                          minInSpan = minInSpan, bpSpan = bpSpan,
                          verbose = verbose,
                          parallel = parallel)
      meanMeth_chr <- fit_chr %>% pmax(0) %>% pmin(1)
      if (verbose) message("Mean methylation smoothed. ", appendLF = FALSE)
    } else {
      meanMeth_chr <- origin_mean_chr
    }

    # Compute variance relative to meanMeth
    var_chr <- computeVar(gr = gr_chr,
                          M = M_chr,
                          meanMeth = meanMeth_chr,
                          bpWindow = bpWindow,
                          sparseNAdrop = sparseNAdrop,
                          parallel = parallel)
    t2 <- proc.time()
    if (verbose) message("Variance computed (", round((t2 - t1)[3]/60, 2), " min). ")

    meanMeth <- c(meanMeth, meanMeth_chr)
    var <- c(var, var_chr)
  } # end looping chromosome

  if (meanSmooth) values(gr)$smoothed_mean <- meanMeth
  values(gr)$var <- var

  return(gr)
}

---
title: "Analyzing single-cell bisulfite sequencing data with vmrseq"
author:
- name: Ning Shen
  affiliation: 
  - Department of Statistics, University of British Columbia; 
  - Centre for Molecular Medicine and Therapeutics, BC Children's Hospital Research Institute
  email: ning.shen@stat.ubc.ca
output: 
  rmarkdown::html_vignette:
  BiocStyle::html_document:
    toc: true
    toc_depth: 3
    toc_float: true
    number_sections: true
    fig_width: 9
    fig_height: 4.5
vignette: >
  %\VignetteIndexEntry{Analyzing single-cell bisulfite sequencing data with vmrseq}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "##"
)
```

# Citation

**If you use vmrseq in published research, please cite: **

Shen, Ning, and Keegan Korthauer. "vmrseq: Probabilistic Modeling of Single-Cell Methylation Heterogeneity." bioRxiv, November 21, 2023. https://doi.org/10.1101/2023.11.20.567911.


# Installation

This package will be submitted to Bioconductor. For now, you can install the development version from Bioconductor (recommended) or our [GitHub repository](https://github.com/nshen7/vmrseq) through running this:

```{r installation, eval = FALSE}
### Install stable version from Bioconductor
 if (!require("BiocManager", quietly = TRUE))
     install.packages("BiocManager")
BiocManager::install("vmrseq")

## Or development version from Github
# install.packages("remotes")
remotes::install_github("nshen7/vmrseq")
```

After installation, load the vmrseq package:

```{r setup, warning=F, message=F}
library(vmrseq)
```


How to get help for vmrseq: Feel free to raise questions by opening issue(s) in the [vmrseq GitHub repository](https://github.com/nshen7/vmrseq)

# Background

High-throughput single-cell measurements of DNA methylation allows studying inter-cellular epigenetic heterogeneity, but this task faces the challenges of sparsity and noise. We present `vmrseq`, a statistical method that overcomes these challenges to accurately  and robustly identify de novo variably methylated regions (VMR) in single-cell DNA methylation data. To the best of our knowledge, vmrseq has been the only method that flexibly pinpoints biologically relevant regions at single-base pair resolution without prior knowledge of size or location. In addition, vmrseq is the only approach capable of detecting VMRs that are sensitive to the level of heterogeneity present in input datasets so far.

```{r vmrseq, fig.retina = NULL, fig.align='center', fig.wide = TRUE, echo=FALSE}
knitr::include_graphics("../man/figures/method.png", dpi = 300)
```


# Input data

vmrseq takes processed and filtered single-cell bisulfite sequencing **binary** methylation values as input. After processing and filtering, each sequenced CpG takes a value of methylated or unmethylated in each cell.

## On the note of pre-processing

In the experiments of the vmrseq manuscript, the authors did not carry out the pre-processing but instead, adopted the processed .bam files provided by the original publications of the sequencing protocol and datasets. However, by summarizing the processing steps described in those publications as sources, we offer a flexible guideline intended to serve as a general reference rather than a strict requirement: 

1. Remove cells with a low non-conversion rate (e.g., $\leq1\%$ in mouse and $\leq2\%$ in human). 
1. To eliminate contaminated samples, remove cells with a low number of non-clonal mapped reads (e.g., 400K in mouse; 500K in human). 
1. To protect against wells with multiple cells, remove cells exceeding an upper limit on coverage ($\leq15\%$ of cytosines). 
1. Remove cells with low CpG site coverage (e.g., $\leq50,000$ CpG sites)


## Process individual-cell read files

We have implemented a `poolData` function to process individual-cell read files into a format that is suitable to input to the vmrseq framework. Following is an example of how to use this function.

The `poolData` function pools individual-cell CpG read files into a SummarizedExperiment object (with *NA-dropped sparseMatrix representation* by default). Store the file paths of individual cells to a list, for example, called `cell_list`, and input it to `poolData` function. `poolData` does not give any output but directly writes the SummarizedExperiment object into the `writeDir` specified by the user, here is an example: (this step might take long in practice since input datasets usually contain many cells; suggest to parallelize the computation with chromosomes)
```{r eval = F}
poolData(cellFiles = cell_list, sep = ",", chrNames = "chr1", writeDir = "your/write/path")
```
Note that in each cell, sites with hemimethylation or intermediate methylation levels (i.e., 0 < meth_read/total_read < 1) will be removed.

Each cell file should be in BED-like format, where the first 5 columns in each file must be: *chr*, *pos*, *strand*, *meth_read*, *total_read*, in strict order, for example:
```{r}
data("cell_1")
head(cell_1)
```


The `SummarizedExperiment` object stores CpG sites as rows and cells as columns. We adopted the NA-dropped sparseMatrix representation to save storage space for large single-cell datasets (see following section for specifics of how this representation look like). This option can be turned off but we recommend to keep it on. 

Further, `poolData` saves the `SummarizedExperiment` object into disk using `HDF5` format, which is a backend extension of `DelayedArray`. The HDF5/DelayedArray format allows one to perform common array operations on it without loading the object in memory. See packages [HDF5Array](https://bioconductor.org/packages/release/bioc/html/HDF5Array.html) and [DelayedArray](https://bioconductor.org/packages/release/bioc/html/DelayedArray.html) for details.


## Load example data

In this vignette, we use a formatted example dataset built in the package that's ready to be input to model fitting function (which is not accessible to users due to format limitation of internal data of R packages). In usual cases users of this package would use `HDF5::loadHDF5SummarizedExperiment` to load saved HDF5SummarizedExperiment objects into R. 

```{r}
toy.se <- HDF5Array::loadHDF5SummarizedExperiment(system.file("extdata", "toy", package = "vmrseq"))
```

It is a `SummarizedExperiment` object with one `assays` slot called `M_mat` that contains the binary methylation values of individual cells at CpG sites (sites as rows and cells as columns):
```{r}
toy.se
```
```{r}
dim(toy.se)
```


```{r}
GenomicRanges::granges(toy.se)
```


```{r}
SummarizedExperiment::assays(toy.se)
```

Moreover, the assay matrix is in *NA-dropped sparseMatrix representation* (implemented using the `recommenderlab::dropNA` function):
```{r}
SummarizedExperiment::assays(toy.se)$M_mat[5:10, 5:10]
```
In particular, the NAs in the dataset are represented by 0 (or 0.000000e+00 as shown above), and the 0's are represented in a very small positive real number (2.225074e-308 as shown above). This allows the matrix to be stored in a `sparseMatrix` format so that it takes less disk storage. One can use the `vmrseq::HDF5NAdrop2matrix` function to convert the assay from HDF5SummarizedExpriment object saved by `vmrseq::poolData` back to regular matrices.

## Filter out low-cell-coverage sites
Prior to applying vmrseq, we filter out CpG sites with total number of covered cells < 3. Note that the `assays(toy.se)$M_mat`, which stores the binary methyation values per site and per cell, is in *NA-dropped sparseMatrix representation* (see above section). Therefore, to count the covered cells per CpG, we count the number of non-zero values per row.
```{r}
total <- DelayedArray::rowSums(SummarizedExperiment::assays(toy.se)$M_mat > 0)
toy.se <- subset(toy.se, total >= 3)
```

```{r}
dim(toy.se)
```

# Detect variably methylated regions (VMR)

## Brief intro on the vmrseq method

vmrseq is a two-stage approach that first constructs candidate regions and then determines whether a VMR is present and its location if applicable. The first stage of vmrseq scans the genome for regions containing consecutive CpGs that show evidence of potential cell-to-cell variation. vmrseq first applies smoothing to mitigate the influence of limited coverage and counteract the reduction in statistical power caused by the inherent noise in single-cell data. The candidate regions are defined as groups of consecutive loci that exceed some threshold on the inter-cellular variance of smoothed methylation levels. 

The second stage of vmrseq optimizes a hidden Markov model that models methylation states of individual CpG sites for each candidate region. The estimation of parameters and hidden states in the HMM determines whether groups of cell subpopulations show distinct epigenetic signals in each region and solves for the precise genomic range of VMRs.

For more details, refer to the **vmrseq** paper (Shen et al. 2023).


## On the note of computational time

The use of parallelization can sufficiently lower computation time of vmrseq. To use more cores, use the `register` function of [BiocParallel](http://bioconductor.org/packages/BiocParallel). For example, the following chunk (not evaluated here), would register 8 cores, and then the functions above would split computation over these cores.

```{r eval = F}
library("BiocParallel")
register(MulticoreParam(8))
```

Generally, the computation time of vmrseq depends on not only the number of cores, but also the level of heterogeneity presents in input data. **Thus we suggest users to first run vmrseq on a small subset of the cells and CpG sites of the input dataset to test out the computational burden before apply the method on the complete dataset.**


## Run vmrseq method

The standard VMR analysis steps are wrapped into two functions, `vmrseqSmooth` and `vmrseqFit`. The estimation steps performed by them are described briefly below, as well as in more detail in the vmrseq paper. Here we run the results for a subset of 30,000 CpGs in 200 cells in the interest of computation time.

The `vmrseqSmooth` function performs kernel smoothing on the single-cell methylation and output a `GRanges` object with the CpG coordinate information extracted from the input `toy.se` and metadata columns indicating the methylated cell count (i.e., <meth>), the total cell coverage (i.e., <total>) and the inter-cellular variance on methylation level.
```{r}
toy.gr <- vmrseqSmooth(toy.se)
```
```{r}
head(toy.gr)
```


Next, the `vmrseqFit` function performs rest steps of the method, i.e., defining the candidate regions based on the variance and fitting the hidden Markov model to detect the VMRs. 
```{r}
toy.results <- vmrseqFit(toy.gr)
```

For users who need a preliminary check or prioritize speed over high precision in region detection and the ranking of regions, we recommend running only the first stage of the methodology. This allows for a faster initial analysis before applying the full methodology. This can be achieved by specifying the argument `stage1only = TRUE` in the `vmrseqFit` function.
```{r}
toy.results_s1 <- vmrseqFit(toy.gr, stage1only = TRUE)
```


## Method output

```{r}
toy.results
```

The toy.results object is a list of 6 elements that contains the following information:

  1. `gr`: The `Granges` object that has been input to `vmrseqFit` with two added metadata columns:
      + `cr_index` = Index in reference to rows of `cr.ranges`, denoting row number of the candidate region to which the CpG site belongs.
      + `vmr_index` = Index in reference to rows of `vmr.ranges`, denoting row number of the variably methylated region to which the CpG site belongs.
  2. `vmr.ranges`: A `Granges` object with the coordinates of each detected variably methylated region (each row is a VMR), with metadata columns:
      + `num_cpg` = Number of observed CpG sites in the VMR.
      + `start_ind` = Index of the starting CpG sites in reference to rows of `gr`.
      + `end_ind` = Index of the ending CpG sites in reference to rows of `gr`.
      + `pi` = Prevalence of the methylated grouping (see manuscript for details)
      + `loglik_diff` = Difference in log-likelihood of two-grouping and one-grouping HMM fitted to the VMR; can be used to rank the VMRs.
  3. `cr.ranges`: A `Granges` object with the coordinates of each candidate region (each row is a candidate region), with metadata column:
      + `num_cpg` = Number of observed CpG sites in the candidate region.
  4. `alpha`: Designated significance level (default 0.05, can be changed by user with function argument). It is used for determining the threshold on variance used for constructing candidate. The threshold is computed by taking the $1-\alpha$ quantile of an approximate null distribution of variance (see manuscript for details).
  5. `var_cutoff`: Variance cutoff computed from `alpha`.
  6. `bb_params`: Beta-binomial parameter used in emission probability of the HMM model; they are determined by the magnitude of the input dataset (see manuscript for details). 

In summary, vmrseq found `r length(toy.results$cr.ranges)` candidate regions, among which `r length(toy.results$vmr.ranges)` contains VMR.


If the argument `stage1only = TRUE` has been turned on, the output only contains four of the above-mentioned elements: `gr`, `cr.ranges`, `alpha`, `var_cutoff`. 
```{r}
names(toy.results_s1)
```


# Compute region-level methylation

We also provide a function called `regionSummary` to compute regional methylation information for downstream analysis. As an example, we use this function to summarize the regional info of the detected VMRs from `toy.se`:
```{r}
regions.se <- regionSummary(SE = toy.se, region_ranges = toy.results$vmr.ranges)
regions.se
```
The function output a SummarizedExperiment object of dimension (# regions x # cells). In total the object contains thress assays. Specifically, `M` and `Cov` represent the number of methylated CpGs and the number of covered CpGs in each region per cell; and `MF` (stands for methylation fraction) represents the regional average methylation level computed by `M/Cov`. Note that `MF` contains NAs due to zero counts in the `Cov` matrix.

```{r}
SummarizedExperiment::assays(regions.se)$MF[1:5, 1:5]
```

# Downstream analysis

We have created the GitHub repo [vmrseq-workflow-vignette](https://github.com/nshen7/vmrseq-workflow-vignette) as a demo of complete workflow of scBS-seq analysis using vmrseq. This repo includes scripts that run vmseq and apply downstream analysis such as gene/CpG annotation and clustering analysis. Feel free to check it out!

# Session info

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regionSummary.R
\name{regionSummary}
\alias{regionSummary}
\title{Compute regional methylation information for individual cells.}
\usage{
regionSummary(
  SE,
  region_ranges,
  sparseNAdrop = is_sparse(assays(SE)[[1]]),
  verbose = TRUE,
  BPPARAM = BiocParallel::bpparam()
)
}
\arguments{
\item{SE}{\code{SummarizedExperiment} object with one (and only one) assay that
contains *binary* methylation status of CpG sites in individual cells. In usual
analysis workflow (of vmrseq), \code{SE} should be the output of \code{vmrseq::data.pool}.}

\item{region_ranges}{\code{GRanges} object that contains genomic coordinates
of regions of interest.}

\item{sparseNAdrop}{logical value that represents whether the NA values are
droppped in the input \code{SE} object. \code{SE} objects output by
\code{vmrseq::data.pool} are NA dropped. See \code{?vmrseq::data.pool}
for details about NA-dropped representation.}

\item{verbose}{logical value that indicates whether progress messages
should be printed to stdout. Defaults value is TRUE.}

\item{BPPARAM}{a \code{BiocParallelParam} object to specify the parallel
backend. The default option is \code{BiocParallel::bpparam()} which will
automatically creates a cluster appropriate for the operating system.}
}
\value{
Returns a \code{SummarizedExperiment} object of dimension 
(# regions x # cells). In total the object contains thress assays. Specifically, 
`M` and `Cov` represent the number of methylated CpGs and the number of covered 
CpGs in each region per cell; and `MF` (stands for methylation fraction) represents 
the regional average methylation level computed by `M/Cov`.
}
\description{
This function summarize the methylated CpG count and total CpG count
per region per cell.
}
\examples{

# load example data
toy.se <- HDF5Array::loadHDF5SummarizedExperiment(system.file("extdata", "toy", package = "vmrseq"))
data(toy.results)

# run vmrseq.fit
regions.se <- regionSummary(SE = toy.se, region_ranges = toy.results$vmr.ranges[1:3])
regions.se

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vmrseqOptimControl.R
\name{vmrseqOptimControl}
\alias{vmrseqOptimControl}
\title{Auxiliary function as user interface for vmrseq optimization.}
\usage{
vmrseqOptimControl(
  inits = c(0.2, 0.5, 0.8),
  epsilon = 0.001,
  backtrack = TRUE,
  eta = ifelse(backtrack, 0.05, 0.005),
  maxIter = 100
)
}
\arguments{
\item{inits}{vector of numeric values between 0 and 1 representing initial
values of pi_1 shall be taken in optimization algorithm.}

\item{epsilon}{numeric value representing the convergence upper bound for
the algorithm.}

\item{backtrack}{logical value indicating whether to use backtracking line
search to automatically adjust learning rate. Default is TRUE.}

\item{eta}{a numeric value representing the learning rate in optimization.
Default is \code{ifelse(backtrack, 0.05, 0.005)}.}

\item{maxIter}{positive integer value representing the maximum number of
iterations in optimization algorithm.}
}
\value{
the list of arguments for optimization control
}
\description{
Typically only used when calling vmrseq function with the
option \code{control}.
}
\examples{
vmrseqOptimControl()


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HDF5NAdrop2matrix.R
\name{HDF5NAdrop2matrix}
\alias{HDF5NAdrop2matrix}
\title{Coerce a NA-dropped HDF5 matrix back to regular matrix form where NAs are not
dropped to 0.}
\usage{
HDF5NAdrop2matrix(hdf5_assay)
}
\arguments{
\item{hdf5_assay}{an DelayedMatrix object with dropped NA values (e.g. an
assay from HDF5SummarizedExpriment object saved by vmrseq::data.pool)}
}
\value{
Returns a matrix.
}
\description{
Coerce a NA-dropped HDF5 matrix back to regular matrix form where NAs are not
dropped to 0.
}
\examples{
# load example data
toy.se <- HDF5Array::loadHDF5SummarizedExperiment(system.file("extdata", "toy", package = "vmrseq"))

# run the function
HDF5NAdrop2matrix(SummarizedExperiment::assays(toy.se)$M_mat)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helper_functions.R
\docType{data}
\name{toy.gr}
\alias{toy.gr}
\title{toy.gr}
\format{
A \code{GRanges} object.
}
\usage{
data(toy.gr)
}
\description{
This \code{GRanges} object. It was generated by running the example from 
\code{vmrseq::vmrseqSmooth} function.
}
\examples{
data(toy.gr)
toy.gr

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vmrseqFit.R
\name{vmrseqFit}
\alias{vmrseqFit}
\title{Construct candidate regions and detect variably methylated regions.}
\usage{
vmrseqFit(
  gr,
  alpha = 0.05,
  maxGap = 2000,
  stage1only = FALSE,
  minNumCR = 5,
  minNumVMR = 5,
  gradient = TRUE,
  tp = NULL,
  control = vmrseqOptimControl(),
  verbose = TRUE,
  BPPARAM = BiocParallel::bpparam()
)
}
\arguments{
\item{gr}{\code{GRanges} object output by \code{vmrseq::vmrseqSmooth},
containing genomic coordinates (chr, start, end) and summarized information
(meth, total, var) of CpG sites in the input dataset.}

\item{alpha}{positive scalar value between 0 and 1 that represents the
designated significance level for determining variance threshold of candidate
regions construction. The variance threshold is determined by taking 1-alpha
quantile value of an approximate null distribution of variance simulated
from the beta priors of emission probability in the hidden Markov model.
Default value of alpha is 0.05.}

\item{maxGap}{integer value representing maximum number of base pairs in
between neighboring CpGs to be included in the same VMR. Default value is
2000 bp.}

\item{stage1only}{boolean value indicating whether the algorithm should run
stage 1 of vmrseq (the construction of candidate regions) only. If set to TRUE,
the function will output only the candidate regions. Default is FALSE.}

\item{minNumCR}{positive integer value representing the minimum number of
CpG sites within a candidate region. Default value is 5.}

\item{minNumVMR}{positive integer value representing the minimum number of
CpG sites within a variably methylated region. Default value is 5.}

\item{gradient}{logical value indicating whether exponentiated gradient
descent shall be applied to update prevalence parameter. Default is TRUE. If
set as FALSE, initial values (i.e., value of \code{inits} arguments in
\code{vmrsqe::vmrseqOptimControl}, can be set up in the \code{control}
argument of this function) are used as prevalence parameter for decoding
hidden states.}

\item{tp}{a `transitProbs-class` object that contains the transition
probability distribution used for HMM optimization. Default value is
transition probability \code{vmrseq:::tp0} built in the package that was
previously trained on mouse brain cells. See manuscript for training
procedure and data source.}

\item{control}{list of miscellaneous parameters used to control optimization
of the HMM model. Default is output of \code{vmrseq::vmrseqOptimControl()}.
Can be changed by tweaking arguments in function \code{vmrseq::vmrseqOptimControl()}.}

\item{verbose}{logical value that indicates whether progress messages
should be printed to stdout. Defaults value is TRUE.}

\item{BPPARAM}{a \code{BiocParallelParam} object to specify the parallel
backend. The default option is \code{BiocParallel::bpparam()} which will
automatically creates a cluster appropriate for the operating system.}
}
\value{
The results object is a list of 6 elements that contains the following information:
1. `gr`: The `Granges` object that has been input to `vmrseqFit` with two added metadata columns:
    + `cr_index` = Index in reference to rows of `cr.ranges`, denoting row number of the candidate region to which the CpG site belongs.
    + `vmr_index` = Index in reference to rows of `vmr.ranges`, denoting row number of the variably methylated region to which the CpG site belongs.
2. `vmr.ranges`: A `Granges` object with the coordinates of each detected variably methylated region (each row is a VMR), with metadata columns:
    + `num_cpg` = Number of observed CpG sites in the VMR.
    + `start_ind` = Index of the starting CpG sites in reference to rows of `gr`.
    + `end_ind` = Index of the ending CpG sites in reference to rows of `gr`.
    + `pi` = Prevalence of the methylated grouping (see manuscript for details)
    + `loglik_diff` = Difference in log-likelihood of two-grouping and one-grouping HMM fitted to the VMR; can be used to rank the VMRs.
3. `cr.ranges`: A `Granges` object with the coordinates of each candidate region (each row is a candidate region), with metadata column:
    + `num_cpg` = Number of observed CpG sites in the candidate region.
4. `alpha`: Designated significance level (default 0.05, can be changed by user with function argument). It is used for determining the threshold on variance used for constructing candidate. The threshold is computed by taking the (1-alpha) quantile of an approximate null distribution of variance (see manuscript for details).
5. `var_cutoff`: Variance cutoff computed from `alpha`.
6. `bb_params`: Beta-binomial parameter used in emission probability of the HMM model; they are determined by the magnitude of the input dataset (see manuscript for details).
}
\description{
Construct candidate regions (CRs) by taking groups of consecutive loci that exceed
threshold on the variance of smoothed relative methylation levels and detect
variably methylated regions (VMRs) by optimizing a hidden Markov model (HMM).
}
\examples{
# load example data
data(toy.gr)
# run vmrseqFit
toy.results <- vmrseqFit(toy.gr)
toy.results

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helper_functions.R
\docType{data}
\name{toy.results}
\alias{toy.results}
\title{toy.results}
\format{
A \code{GRanges} object.
}
\usage{
data(toy.results)
}
\description{
This \code{list} object. It was generated by running the example from 
\code{vmrseq::vmrseqFit} function.
}
\examples{
data(toy.results)
toy.results

}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tpEstimate.R
\name{tpEstimate}
\alias{tpEstimate}
\title{Estimate transition probilities conditioning on CpG-CpG distance}
\usage{
tpEstimate(
  list,
  max_dist_bp = 2000,
  buffer_bp = 3000,
  lags = 1:10,
  BPPARAM = bpparam(),
  degree = 2,
  span = 0.02,
  ...
)
}
\arguments{
\item{list}{a list of data.frame objects. Each data.frame
contains information of 1 unit of training data (can be a cell or a
subtype) and should have 3 columns in strict rder of: (chr), (pos),
(binary methyl value). Column names are not necessary.}

\item{max_dist_bp}{positive integer value indicating the maximum
CpG-CpG distance in base pairs before the transition probabilities
reach constant value. Default value is 2000.}

\item{buffer_bp}{length of buffer in base pairs used to fit smoothing
curve near maximum distance and plot diagnostics. Default is 3000.}

\item{lags}{a vector indicating possible number of lagged CpGs for
estimation of transition probabilities.}

\item{BPPARAM}{a \code{BiocParallelParam} object to specify the parallel
backend. The default option is \code{BiocParallel::bpparam()} which will
automatically creates a cluster appropriate for the operating system.}

\item{degree}{'degree' argument for `loess` function}

\item{span}{'span' argument for `loess` function}

\item{...}{additional arguments passed into the `loess` function.}
}
\value{
a 'transitProbs' object. Postfixes rule in the output variables:
P(0|0) => '00'; P(0|1) => '01'; P(1|0) => '10'; P(1|1) => '11'.
}
\description{
This function first computes transition probilities
conditioning on CpG-CpG distance in each cell. Then the probs from
individual cells are smoothed over CpG-CpG distance using `loess`
with inverse-variance fitting.
}
\examples{

# load example data
data(cell_1, cell_2, cell_3)

# process the data to align with input format
library(dplyr)
df_1 <- cell_1 \%>\% mutate(meth = round(mc_count / total)) \%>\% select(chr, pos, meth)
df_2 <- cell_2 \%>\% mutate(meth = round(mc_count / total)) \%>\% select(chr, pos, meth)
df_3 <- cell_3 \%>\% mutate(meth = round(mc_count / total)) \%>\% select(chr, pos, meth)

# run tpEstimate
list <- list(df_1, df_2, df_3)
tpEstimate(list)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helper_functions.R
\docType{data}
\name{cell_1}
\alias{cell_1}
\title{cell_1}
\format{
A data frame with 10000 rows and 5 variables (no column names):
\describe{
  \item{chr}{Chromosome}
  \item{mc_count}{Genomic coordinate}
  \item{pos}{Strand information}
  \item{strand}{Number of methylated reads}
  \item{total}{Number of reads in total}
}
}
\usage{
data(cell_1)
}
\description{
This dataset is an example of a single-cell file that can be input to
\code{vmrseq::poolData} function. It contains the first 10000 CpG sites in
a random cell from mouse frontal cortext dataset published by Luo et al. (2017).
}
\examples{
data(cell_1)
head(cell_1)

}
\references{
Luo, Chongyuan et al. \emph{Single-cell methylomes identify neuronal
subtypes and regulatory elements in mammalian cortex.}. Science (New York, N.Y.)
vol. 357,6351 (2017): 600-604.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vmrseqSmooth.R
\name{vmrseqSmooth}
\alias{vmrseqSmooth}
\title{Smoothing on single-cell bisulfite sequencing data for the purpose of
constructing candidate regions.}
\usage{
vmrseqSmooth(
  SE,
  bpWindow = 2000,
  sparseNAdrop = is_sparse(assays(SE)[[1]]),
  verbose = TRUE,
  BPPARAM = bpparam()
)
}
\arguments{
\item{SE}{\code{SummarizedExperiment} object with one (and only one) assay that
contains *binary* methylation status of CpG sites in individual cells. We
recommend using output by \code{\link{poolData}} (i.e., an NA-dropped
HDF5-based SummarizedExperiment object) to prevent running out of memory.}

\item{bpWindow}{positive integer that represents the width (in bp) of
smoothing window. Default value is 2000.}

\item{sparseNAdrop}{logical value that represents whether the NA values are
droppped in the input \code{SE} object. \code{SE} objects output by
\code{\link{poolData}} are NA dropped. See \code{?vmrseq::poolData}
for details about NA-dropped representation.}

\item{verbose}{logical value that indicates whether progress messages
should be printed to stdout. Defaults value is TRUE.}

\item{BPPARAM}{a \code{BiocParallelParam} object to specify the parallel
backend. The default option is \code{BiocParallel::bpparam()} which will
automatically creates a cluster appropriate for the operating system.}
}
\value{
a \code{GRanges} object that contains the result of smoothing.
 The object retains genomic coordinates (chr, start, end) of input CpG
 sites, in the same order as in the input \code{SE} object. Three
 column are added (on top of original metadata columns for the CpG sites in
 \code{SE}, if any):
 1. meth: methylated cell count of the CpG
 2. total: total (non-missing) cell count of the CpG
 3. var: variance computed based on individual-cell smoothed relative methylation levels.
}
\description{
\code{vmrseqSmooth} takes a \code{SummarizedExperiment} object
 with information of methylation level of individual cells as input, and
 perform a kernel smoother to ‘relative’ methylation levels of individual
 cells prior to constructing candidate regions. Purpose of the smoothing is
 to adjust for uneven coverage biases and borrow information from nearby sites.
 See manuscript for detailed description.
}
\examples{
# load example data
toy.se <- HDF5Array::loadHDF5SummarizedExperiment(system.file("extdata", "toy", package = "vmrseq"))

# preprocessing
total <- DelayedArray::rowSums(SummarizedExperiment::assays(toy.se)$M_mat > 0)
toy.se <- subset(toy.se, total >= 3)

# run vmrseqSmooth
toy.gr <- vmrseqSmooth(toy.se)
toy.gr

}
\seealso{
\code{\link{poolData}}, \code{\link{vmrseqFit}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/poolData.R
\name{poolData}
\alias{poolData}
\title{Pool single-cell file together into an HDF5-based SummarizedExperiment
object with sparse matrix representation.}
\usage{
poolData(
  cellFiles,
  sep,
  writeDir,
  chrNames,
  colData = NULL,
  sparseNAdrop = TRUE
)
}
\arguments{
\item{cellFiles}{Vector of character strings indicating single-cell file
paths you wish to pool into SE object(s). Cell files should be in BED-like
format, where the first 5 columns in each file must be: <chr>, <pos>, <strand>,
<meth_read>, <total_read>, in strict order. Each row contains info of one CpG.
Strand is assumed to be properly filpped. Cell files can be zipped ones in .gz
format.}

\item{sep}{the field separator character. Values on each line of cell file are
separated by this character.}

\item{writeDir}{A single character string indicating a folder directory where
you wish to store the processed SE object(s). The SE will be stored in HDF5 format.}

\item{chrNames}{Single or a vector of character strings representing chromosome
names in cell files. Only chromosomes listed in \code{selectChrs} will be
processed.}

\item{colData}{A DataFrame or data.frame object containing colData for the SE
object (applied to all chromosomes).}

\item{sparseNAdrop}{Logical value indicating whether or not to use NA-dropped
sparseMatrix representation. 'NA-dropped' means replacing NAs as zeros and
then represent 0 as a very small positive value close to 0 so that the data
matrix is converted to a traditional sparseMatrix form with 0 as default
entry value. (see \code{sparseNAMatrix-class} from package \code{recommenderlab}).
Using NA-dropped sparseMatrix representation helps to save RAM during data
processing, as well as storage space saving to disk. Currently only supports
TRUE!!}
}
\value{
Directly write out to the `writeDir` and does not return anything.
}
\description{
This function pools individual-cell CpG read files into a
SummarizedExperiment object so that it can be input to the \code{vmrseq.smooth}
function. Note that in each cell, sites with hemimethylation or intermediate
methylation levels (i.e., 0 < meth_read/total_read < 1) will be removed.
}
\examples{
\donttest{poolData(cellFiles = your_cell_file_list, sep = ",", chrNames = "chr1", writeDir = "your/write/path")}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tpPlot.R
\name{tpPlot}
\alias{tpPlot}
\title{Plot transition probability distribution}
\usage{
tpPlot(tp, line_size = 0.2, plot_train = TRUE, point_size = 0.2)
}
\arguments{
\item{tp}{'transitProbs' object storing information about trained transition
probabilities. Can be obtained from function `estimTransitProbs`}

\item{line_size}{size of fitted loess smooth line. Default value is 0.2.}

\item{plot_train}{logical value indiating whether to plot training data.
Default is TRUE.}

\item{point_size}{size of training data points. Only applicable when
`plot_train = T`. Default value is 0.2.}
}
\value{
A plot of the transition probability distribution
}
\description{
Plot transition probability distribution
}
\examples{
tpPlot(vmrseq:::tp0)

}
